/*  ace handling functions
 *  Copyright 2000-2001 Lucian Langa
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <unistd.h>
#include <pwd.h>
#include <wait.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "interface.h"
#include "conf.h"
#include "archs.h"
#include "gnochive.h"
#include "zip.h"
#include "gnochive.h"

#define TIMEOUT_GTK 5

extern gchivemain *gnochivemain;

extern GdkPixmap 	*dirpix,*docpix,*xpmpix,*makpix;
extern GdkPixmap	*rpmpix,*comppix,*dotpix,*lockpix;
extern GdkPixmap *hdrpix,*sympix,*rdpix,*rpm1pix;

extern GdkBitmap 	*dirmask,*docmask,*xpmmask,*makmask;
extern GdkBitmap	*rpmmask,*compmask,*dotmask,*lockmask;
extern GdkBitmap *hdrmask,*symmask,*rdmask,*rpm1mask;

extern gchar *arc_type;

extern GtkWidget *arcmenu1;

extern gchar *directory_read;
extern gchar *directory_up;

gchar *opd_archive_name;

extern gfloat step;
extern float progr;

extern int last_select_row;

static guint mytime(gpointer data);

/*	0 - no error, file opened
	1 - error not a rar archive
*/
int
ace_open(pager	*page, gchar *file_name)
{
	int status = 0;
	int vline = 0;
	FILE *tempfile;
	gint i=0, j=0;
	gint line=0;
	gint ret,arcsize;
	guint time_id;
	gchar *arcfile = NULL;
	//gchar *rbase = NULL;
	gchar xfr[0x100];
	gchar *myfile = g_strdup(file_name);
	gchar *clist_line[9] = {"","","","","","","","",""};
	gboolean error;
	pid_t pid;
	gchar *temp_name = g_concat_dir_and_file(TMPDIR,"gchiveXXXXXX");
	gchar *temp_name2 = g_concat_dir_and_file(TMPDIR,"gchiveXXXXXX");
	int tf = mkstemp(temp_name);
	int tf2 = mkstemp(temp_name2);
	gchar *dirs[512], *rbase2 = NULL, *tdir = NULL;
	guint k = 0, e = 0;
	gboolean dirprs, is_dr = FALSE;
	
	if (tf && tf2) {
		step = 0.01;
		progr = 0.1;
		
		time_id = gtk_timeout_add(TIMEOUT_GTK, (GtkFunction)mytime, NULL);
		
		pid = gnochive_exec_arch("/tmp/zpvw", "zpvw",
			gnochivemain->gc_cfg->archs.unace_path,
			"v", myfile, temp_name, NULL);
		gnochivemain->current_archive = g_strdup(myfile);
		while (!waitpid(pid, &status, WNOHANG))
		{
			error = (WEXITSTATUS(status)<0);
			while (gtk_events_pending())
				gtk_main_iteration();
		}
		tempfile=fopen(temp_name,"rb");
		if (tempfile) {
			fseek(tempfile,0,SEEK_END);
			arcsize=ftell(tempfile);
			fclose(tempfile);
			while (gtk_events_pending())
				gtk_main_iteration();
			gtk_clist_freeze(GTK_CLIST(page->clist));
			gtk_clist_clear(GTK_CLIST(page->clist));
			clist_line[1] = directory_read;
			gtk_clist_append(GTK_CLIST(page->clist), clist_line);
			clist_line[1] = directory_up;
			gtk_clist_append(GTK_CLIST(page->clist), clist_line);
			gtk_clist_set_pixmap(GTK_CLIST(page->clist), 1, 0, dotpix, dotmask);
			line = vline = 2;
			pid = gnochive_exec_arch("/tmp/zpvw", "zpvw", 
					gnochivemain->gc_cfg->archs.unace_path,
					"v", myfile, temp_name2, NULL);
			while (!waitpid(0,NULL,WNOHANG))
			{
				gtk_main_iteration();
			}
			tempfile=fopen(temp_name2,"rb");
			fseek(tempfile,0,SEEK_END);
			arcsize=ftell(tempfile);
			arcfile=g_malloc0(arcsize);
			fseek(tempfile,0,SEEK_SET);
			ret=fread(arcfile,1,arcsize,tempfile);
			fclose(tempfile);
			i=0;
			while ((arcfile[i]!='|' || arcfile[i]!='') && arcfile[i+1]!='F')
				i++;
			while (arcfile[i]!=0x0A) i++;
			i++;
			while (arcfile[i]!=0x0A) i++;
			i++;
			while (arcfile[i]!=0x0A && arcfile[i+1]!=0x20) {
				j=0;line++;
				while (arcfile[i]!='|' && arcfile[i]!='') {
					xfr[j]=arcfile[i];				//xfrdta
					i++;j++;
				}
				xfr[j]=' ';i++;j++;
				while (arcfile[i]!='|' && arcfile[i]!='') {
					xfr[j]=arcfile[i];
					i++;j++;
				}
				xfr[j]='\0';
				clist_line[5]=g_strdup(xfr);
				j=0;i++;
				while (arcfile[i]==0x20) i++;
				while (arcfile[i]!='|' && arcfile[i]!='') {
					xfr[j]=arcfile[i];				//xfrsize
					i++;j++;
				}
				xfr[j]='\0';
				clist_line[3]=g_strdup(xfr);
				j=0;i++;
				while (arcfile[i]==0x20) i++;
				while (arcfile[i]!='|' && arcfile[i]!='') {
					xfr[j]=arcfile[i];				//xfrpck
					i++;j++;
				}
				xfr[j]='\0';
				clist_line[4]=g_strdup(xfr);
				j=0;i++;
				while (arcfile[i]==0x20) i++;	
				while (arcfile[i]!='|' && arcfile[i]!='') {
					xfr[j]=arcfile[i];				//ratio
					i++;j++;
				}
				xfr[j]='\0';
				clist_line[8]=g_strdup(xfr);
				j=0;i++;
				while (arcfile[i]==0x20) i++;
				while (arcfile[i]!=0x0A) {
					xfr[j]=arcfile[i];				//xfrchr
					i++;j++;
				}
				xfr[j]='\0';
				clist_line[1] = g_strdup(xfr);
				i++;
				is_dr = FALSE;
				tdir = extract_root_word(clist_line[1], 1);	
				if (e==0)
				{
					if (is_dr) 
					{
						dirs[e] = extract_root_word(clist_line[1], 1);
						e++;
						(gchar *)clist_line[1] = tdir;
						gtk_clist_append(GTK_CLIST(page->clist), clist_line);
						gtk_clist_set_pixmap(GTK_CLIST(page->clist),
							vline, 0, dirpix, dirmask);
						vline++;
						is_dr = FALSE;
					}
					else
					{
						if (!process_line(clist_line[1])) {
							gtk_clist_append(GTK_CLIST(page->clist), clist_line);
							gtk_clist_set_pixmap(GTK_CLIST(page->clist),
								vline, 0, docpix, docmask);
							vline++;
						}
						else
						{
							rbase2 = extract_root_word(clist_line[1], 1);
							dirprs = FALSE;
							for (k=0;k<e;k++)
							{
								if (!cmpare(dirs[k], rbase2))
									dirprs = TRUE;
							}
							g_free(rbase2);
							if (!dirprs)
							{
								dirs[e] = extract_root_word(clist_line[1], 1);
								e++;
								/* found a new dir and append it in the clist */
								(gchar *)clist_line[1] = extract_root_word(clist_line[1], 1);
								(gchar *)clist_line[3] = g_strdup("0");
								(gchar *)clist_line[6] = g_strdup("drwxrwxr-x");
								gtk_clist_append(GTK_CLIST(page->clist), clist_line);
								gtk_clist_set_pixmap(GTK_CLIST(page->clist),
									vline, 0, dirpix, dirmask);
								vline++;
							}
						}
					}
				}
				else {
				if (is_dr) 
				{
					is_dr = FALSE;
					dirprs = FALSE;
					for (k=0;k<e;k++)
					{
						if (!cmpare(dirs[k], tdir))
							dirprs = TRUE;
					}
					if (!dirprs)
					{
						dirs[e] = extract_root_word(clist_line[1], 1);
						e++;
						/* found a new dir and append it in the clist */
						(gchar *)clist_line[1] = tdir;
						gtk_clist_append(GTK_CLIST(page->clist), clist_line);
						gtk_clist_set_pixmap(GTK_CLIST(page->clist),
							vline, 0, dirpix, dirmask);
						vline++;
					}
				}
				else
				{
					if (!process_line(clist_line[1])) {
						gtk_clist_append(GTK_CLIST(page->clist), clist_line);
						gtk_clist_set_pixmap(GTK_CLIST(page->clist),
							vline, 0, docpix, docmask);
						vline++;
					}
					else
					{
						dirprs = FALSE;
						for (k=0;k<e;k++)
						{
							if (!cmpare(dirs[k], tdir))
								dirprs = TRUE;
						}
						if (!dirprs)
						{
							dirs[e] = extract_root_word(clist_line[1], 1);
							e++;
							/* found a new dir and append it in the clist */
							(gchar *)clist_line[1] = tdir;
							(gchar *)clist_line[3] = g_strdup("0");
							(gchar *)clist_line[6] = g_strdup("drwxrwxr-x");
							gtk_clist_append(GTK_CLIST(page->clist), clist_line);
							gtk_clist_set_pixmap(GTK_CLIST(page->clist),
								vline, 0, dirpix, dirmask);
							vline++;
						}
					}
				}
			}
			g_free(clist_line[1]);g_free(clist_line[3]);g_free(clist_line[4]);g_free(clist_line[5]);g_free(clist_line[8]);
		}
		page->current_lines = vline;
		page->selected_rows = g_malloc0(page->current_lines);
		status = 1;
		gtk_clist_thaw(GTK_CLIST(page->clist));
		gtk_timeout_remove(time_id);
		gnome_appbar_set_progress(GNOME_APPBAR(gnochivemain->mainbar),1);
	page->ad->data = arcfile;
	page->ad->root = g_strdup("\0");
	page->ad->depth = 1;
	status = 1;
	}
	else 
		status = 0;
	}
	else
		status = 0;
	g_free(myfile);
	close(tf);
	close(tf2);
	remove(temp_name);
	remove(temp_name2);
	g_free(temp_name);
	g_free(temp_name2);
	return status;
}

void
ace_cd		(GtkWidget *clst, gchar *child)
{
	int vline = 0;
	int line = 0;
	int i = 0, j = 0, e = 0, k;
	gchar *tword = NULL;
	gchar *temp = NULL;
	gchar *arcfile = NULL;
	gchar xfr[100];
	gint row, arcsize;
	gchar *clist_line[9] = {"", "", "", "", "", "", "", "", ""};
	gchar *dirs[512];
	gchar *tdir = NULL;
	gboolean is_dr = FALSE, dirprs;
	
		
	line = vline = 2;
	
	//while (gtk_events_pending())
		//gtk_main_iteration();
	gtk_clist_freeze(GTK_CLIST(clst));
	gtk_clist_clear(GTK_CLIST(gnochivemain->active_page->clist));
	g_free(gnochivemain->active_page->selected_rows);
	
	gtk_clist_set_auto_sort(GTK_CLIST(clst), 1);
	gtk_clist_set_sort_column(GTK_CLIST(clst), 2);
	gtk_clist_set_sort_type(GTK_CLIST(clst), GTK_SORT_DESCENDING);
	gtk_clist_sort(GTK_CLIST(clst));
	
	arcfile = gnochivemain->active_page->ad->data;
	arcsize = strlen(arcfile);
	arcsize-=1;
	i=0;
			while ((arcfile[i]!='|' || arcfile[i]!='') && arcfile[i+1]!='F')
				i++;
			while (arcfile[i]!=0x0A) i++;
			i++;
			while (arcfile[i]!=0x0A) i++;
			i++;
			while (arcfile[i]!=0x0A && arcfile[i+1]!=0x20) {
				j=0;line++;
				while (arcfile[i]!='|' && arcfile[i]!='') {
					xfr[j]=arcfile[i];				//xfrdta
					i++;j++;
				}
				xfr[j]=' ';i++;j++;
				while (arcfile[i]!='|' && arcfile[i]!='') {
					xfr[j]=arcfile[i];
					i++;j++;
				}
				xfr[j]='\0';
				clist_line[5]=g_strdup(xfr);
				j=0;i++;
				while (arcfile[i]==0x20) i++;
				while (arcfile[i]!='|' && arcfile[i]!='') {
					xfr[j]=arcfile[i];				//xfrsize
					i++;j++;
				}
				xfr[j]='\0';
				clist_line[3]=g_strdup(xfr);
				j=0;i++;
				while (arcfile[i]==0x20) i++;
				while (arcfile[i]!='|' && arcfile[i]!='') {
					xfr[j]=arcfile[i];				//xfrpck
					i++;j++;
				}
				xfr[j]='\0';
				clist_line[4]=g_strdup(xfr);
				j=0;i++;
				while (arcfile[i]==0x20) i++;	
				while (arcfile[i]!='|' && arcfile[i]!='') {
					xfr[j]=arcfile[i];				//ratio
					i++;j++;
				}
				xfr[j]='\0';
				clist_line[8]=g_strdup(xfr);
				j=0;i++;
				while (arcfile[i]==0x20) i++;
				while (arcfile[i]!=0x0A) {
					xfr[j]=arcfile[i];				//xfrchr
					i++;j++;
				}
				xfr[j]='\0';
				clist_line[1] = g_strdup(xfr);
				i++;
				is_dr = FALSE;
		if (cmpare(xfr, child) == 0)
		{
			//is_dr = sort_dirs(xfr);
			if (e==0 && strcmp(xfr, child) != 0)
			{
				if (is_dr) 
				{
					dirs[e] = extract_root_word(xfr,
						gnochivemain->active_page->ad->depth);
					e++;
					clist_line[1] = trim_root_word(child, xfr);
					clist_line[2] = "dir";
					row = gtk_clist_insert(GTK_CLIST(clst), 0, clist_line);
					gtk_clist_set_pixmap(GTK_CLIST(clst), row, 0, dirpix, dirmask);
					g_free(clist_line[1]);
					vline++;
					is_dr = FALSE;
				}
				else
				{
					gchar *rbase2 = trim_root_word(child, xfr);
					if (!process_line(rbase2)) {
						clist_line[1] = trim_root_word(child, xfr);
						clist_line[2] = " ";
						row = gtk_clist_insert(GTK_CLIST(clst), 0, clist_line);
						gtk_clist_set_pixmap(GTK_CLIST(clst),
							row, 0, docpix,docmask);
						g_free(clist_line[1]);
						vline++;
					}
					else
					{
						gchar *rbase3 = extract_root_word(xfr, gnochivemain->active_page->ad->depth);
						dirprs = FALSE;
						for (k=0;k<e;k++)
						{
							if (!cmpare(rbase3, dirs[k]))
								dirprs = TRUE;
						}
						if (!dirprs)
						{
							dirs[e] = extract_root_word(xfr, gnochivemain->active_page->ad->depth);
							e++;
							/* found a new dir and append it in the clist */
							(gchar *)clist_line[1] = trim_root_word(child, rbase3);
							(gchar *)clist_line[3] = g_strdup("0");
							(gchar *)clist_line[6] = g_strdup("drwxrwxr-x");
							row = gtk_clist_insert(GTK_CLIST(clst), 0, clist_line);
							gtk_clist_set_pixmap(GTK_CLIST(clst), row, 0, dirpix, dirmask);
							g_free(clist_line[1]);
							vline++;
						}
						g_free(rbase3);
					}
					g_free(rbase2);
				}
			}
			else if (e>0  && strcmp(xfr, child) != 0)
			{
				if (is_dr && strcmp(xfr, child) != 0)
				{
					tdir = extract_root_word(xfr,
						gnochivemain->active_page->ad->depth);
					is_dr = FALSE;
					dirprs = FALSE;
					for (k=0;k<e;k++)
					{
						if (!cmpare(tdir, dirs[k]))
							dirprs = TRUE;
					}
					if (!dirprs)
					{
						dirs[e] = extract_root_word(xfr,
							gnochivemain->active_page->ad->depth);
						e++;
						/* found a new dir and append it in the clist */
						(gchar *)clist_line[1] = trim_root_word(child, tdir);
						row = gtk_clist_insert(GTK_CLIST(clst), 0, clist_line);
						gtk_clist_set_pixmap(GTK_CLIST(clst), row, 0, dirpix, dirmask);
						g_free(clist_line[1]);
						vline++;
					}
					g_free(tdir);
				}
				else
				{
					gchar *rbase2 = trim_root_word(child, xfr);
					if (!process_line(rbase2)) {
						clist_line[1] = trim_root_word(child, xfr);
						clist_line[2] = " ";
						row = gtk_clist_insert(GTK_CLIST(clst), 0, clist_line);
						gtk_clist_set_pixmap(GTK_CLIST(clst),
							row, 0, docpix,docmask);
						g_free(clist_line[1]);
						vline++;
					}
					else
					{
						tdir = extract_root_word(xfr,
							gnochivemain->active_page->ad->depth);
						dirprs = FALSE;
						for (k=0;k<e;k++)
						{
							if (!cmpare(dirs[k], tdir))
								dirprs = TRUE;
						}
						if (!dirprs)
						{
							dirs[e] = extract_root_word(xfr,
								gnochivemain->active_page->ad->depth);
							e++;
							/* found a new dir and append it in the clist */
							(gchar *)clist_line[1] = trim_root_word(child, tdir);
							(gchar *)clist_line[3] = g_strdup("0");
							(gchar *)clist_line[6] = g_strdup("drwxrwxr-x");
							row = gtk_clist_insert(GTK_CLIST(clst), 0, clist_line);
							gtk_clist_set_pixmap(GTK_CLIST(clst), row, 0, dirpix, dirmask);
							g_free(clist_line[1]);
							vline++;
						}
						g_free(tdir);
					}
					g_free(rbase2);
				}
			}
		}
		g_free(clist_line[8]);g_free(clist_line[3]);
		g_free(clist_line[4]);g_free(clist_line[5]);
	}
	for (i=0;i<=9;i++)
		clist_line[i] = "\0";
	gtk_clist_set_auto_sort(GTK_CLIST(clst), 0);	
	clist_line[1] = g_strdup(directory_up);
	gtk_clist_prepend(GTK_CLIST(clst), clist_line);
	gtk_clist_set_pixmap(GTK_CLIST(clst), 0, 0, dotpix, dotmask);
	g_free(clist_line[1]);
	clist_line[1] = g_strdup(directory_read);
	gtk_clist_prepend(GTK_CLIST(clst), clist_line);
	g_free(clist_line[1]);
	gnochivemain->active_page->current_lines = vline;
	gnochivemain->active_page->selected_rows = 
						g_malloc0(gnochivemain->active_page->current_lines);
	temp = g_strdup(child);
	if (temp[0] == '/')
	{
		g_free(gnochivemain->active_page->ad->root);
		gtk_entry_set_text(GTK_ENTRY(arcmenu1), "\0");
		gnochivemain->active_page->ad->root = g_strdup("\0");
	}
	else
	{
		g_free(gnochivemain->active_page->ad->root);
		gtk_entry_set_text(GTK_ENTRY(arcmenu1), temp);
		gnochivemain->active_page->ad->root = g_strdup(child);
	}
	g_free(temp);
	gtk_clist_thaw(GTK_CLIST(clst));
	g_free(tword);
}

int
ace_view(void)
{
	GtkWidget *text2 = NULL;
	GtkWidget *window1;/*FIXME!*/
	int status=0;
	gint arcsize;
	gchar *temp_name = g_concat_dir_and_file(TMPDIR,"gchiveXXXXXX");
	gchar *arcfile;
	FILE *tempfile;
	gchar *clist_line[9] = {"","","","","","","","",""};
	int tf = mkstemp(temp_name);
	
	if (tf) {
		gnochive_exec_arch("/tmp/zpvw", "zpvw", 
			gnochivemain->gc_cfg->archs.gzip_path,
			"-d", opd_archive_name, temp_name, NULL);
		wait(0);
		tempfile = fopen(temp_name,"r");
		fseek(tempfile,0L,SEEK_END);
		arcsize=ftell(tempfile);
		arcfile = g_malloc(arcsize);
		fseek(tempfile,0L,SEEK_SET);
		fread(arcfile,arcsize,1,tempfile);
		fclose(tempfile);
		memset(clist_line,0,sizeof(clist_line));
		window1 = create_view_dialog();
		gtk_widget_show(window1);
		gtk_text_freeze(GTK_TEXT(text2));
		gtk_text_insert(GTK_TEXT(text2),NULL,&text2->style->black,NULL,arcfile,arcsize);
		gtk_text_thaw(GTK_TEXT(text2));
		status = 1;
	}
	else
		status = 0;
	g_free(temp_name);
	remove(temp_name);
	return status;
}

void
ace_sel(gboolean have_context)
{
	gchar *text;
	gchar *ttext = NULL;
	pid_t pid;
	int error;
	gboolean status;
	
	while (gtk_events_pending())
		gtk_main_iteration();
	gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist),last_select_row,1,&text);
	pid = gnochive_exec_arch(gnochivemain->gc_cfg->archs.gzip_path,
		"gzip", "-f", text, NULL);
	while (!waitpid(pid,&status,WNOHANG))
	{
		error=(WEXITSTATUS(status)<0);
		while (gtk_events_pending())
			gtk_main_iteration();
	}
	ttext=g_strdup_printf(N_("%s passed through gzip successfuly!"),text);
	gnome_app_flash(GNOME_APP(gnochivemain->mainwin),ttext);
	g_free(ttext);
	gtk_clist_unselect_row(GTK_CLIST(gnochivemain->active_page->clist),last_select_row,1);
	/* Useful when we're called from contextual menu */
	if (have_context)
	{
		gtk_clist_clear(GTK_CLIST(gnochivemain->active_page->clist));
		read_pwd_files(".");
		g_free(gnochivemain->active_page->selected_rows);
		gnochivemain->active_page->selected_rows=g_malloc0(gnochivemain->active_page->current_lines);
	}
}


/* FIXME! */
void
ace_stat(gchar *name)
{
	int q=0,j=0;
	gint arcsize;
	gchar temp[0x100];
	FILE *tempfile;
	gchar pck[20];
	char ratio[5];
	gint totalpck=0;
	pid_t pid;
	gchar *clist1_line[9] = {"","","","","","","","",""};
	
	pid = gnochive_exec_arch("/tmp/statgz", "stagz",
		gnochivemain->gc_cfg->archs.gzip_path, name, NULL);
	wait(0);
while(gtk_events_pending())
gtk_main_iteration();
tempfile=fopen("/tmp/gzstat1","r");
fseek(tempfile,0L,SEEK_END);
arcsize=ftell(tempfile);
fseek(tempfile,0L,SEEK_SET);
fread(temp,arcsize,1,tempfile);
fclose(tempfile);
q=0x41;
while (temp[q]==0x20) q++;
j=0;
while (temp[q]!=0x20) {
			pck[j]=temp[q];
			j++;q++;
			}
clist1_line[2]=pck;
totalpck=totalpck+atoi(pck);
while (temp[q]==0x20) q++;
j=0;
while (temp[q]!=0x20) q++;
while (temp[q]==0x20) q++;
while (temp[q]!=0x20) {
			ratio[j]=temp[q];
			j++;q++;
			}
			ratio[j++]='\0';
clist1_line[3]=ratio;
}

static 
guint mytime(gpointer data)
{
	GDK_THREADS_ENTER();
	progr=progr+step;
	if (progr<=1)
		gnome_appbar_set_progress(GNOME_APPBAR(gnochivemain->mainbar),progr);
	else gnome_appbar_set_progress(GNOME_APPBAR(gnochivemain->mainbar),1);
	GDK_THREADS_LEAVE();
	return TRUE;
}

/*
 * 0 - unknown
 * 1 - ace archive
 */
 
#define bytes_before_sign 6

gint
detect_ace(gchar *file)
{
int status=0;
FILE *tmp;
gchar buff[0x30];
	
	tmp=fopen(file,"r");
	fread(buff,30,1,tmp);
	fclose(tmp);
	if (cmpare(buff+bytes_before_sign,ACE_MAGIC)==0)
		return 1;
	return status;
}
