/*  GUI frontend for common compresion programs
 *  Copyright 2000-2002  Lucian Langa
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 

#ifndef DND_H
#define DND_H

#include "gnome.h"

typedef struct _dnd mydnd;
struct _dnd
{
	gboolean			*drag_pending;
	gint				press_x;
	gint				press_y;
	GdkEventButton	    *pressed_button;
};

mydnd*
gnochive_drag_init(void);

void gnochive_clist_drag_begin(GtkWidget *widget,
						 GdkDragContext       *context,
						 gpointer              user_data);

void
gnochive_clist_drag_end (GtkWidget *widget, GdkDragContext *context,
			     gpointer user_data);

gboolean 
gnochive_clist_drag_motion (GtkWidget *widget, GdkDragContext *context,
				int x, int y, guint time, gpointer user_data);

gboolean 
gnochive_clist_drag_drop (GtkWidget *widget,
			      GdkDragContext *context,
			      int x, int y, guint time,
			      gpointer user_data);

int 
gnochive_clist_button_press (GtkWidget *widget, GdkEventButton *event);

void 
gnochive_set_dnd_icon (GtkCList *clist, GdkDragContext *context);

void
on_mclist_drag_data_received           (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_aclist_drag_data_received           (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

#endif
