/*  GUI frontend for common compresion programs
 *  Copyright 2000-2001  Lucian Langa
 *
 *	gnochive backend to supported archive formats
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _GC_BK_END_H_
#define _GC_BK_END_H_

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct _archivedesc archivedesc;
struct _archivedesc
{
	gchar 	*name;			//archive name
	gchar 	*full_name;		//archive name + path
	gchar 	*type;
	gint 	 sub_type;
	gchar 	*compress_level;
	gboolean locked;
	gchar 	*passwd;
	guint	 vol_size;
	gchar 	*dict_size;
	gchar 	*data;			//archive hash data
	gchar 	*root;
	gint 	 depth;
	gint 	 volume;
	gint 	 status;
};

typedef struct _pager pger;
	
/* creates an arc_type archive
    if it's a tar like archive (tar.X, rar , zip) gets the file from the clist
    writes the gcparse file and finally creates archive returning 1 on succes
    RETURNS: full name of the created archive
    result should be freed and no longer used.
    FIXME: add single bz2 pack
*/
	
gboolean create_archive	(archivedesc *ad);
gint make_archive (archivedesc *ad,gint update);

archivedesc* open_real_archive(gchar *file_name);
gboolean select_open_function (pger *page, archivedesc *ad);
void refresh_arch (archivedesc *ad);

gchar* get_arch_name_from_type	(gchar *arc_type, gchar *file_name, gint sub_type);
gchar* gnochive_get_archive_type(gchar *filename);

void delete_arc_file				(archivedesc *ad);
void extract_files				(gchar *file_name);
gchar* gnochive_extract_file	(gchar *file_name);
gboolean internal_extract		(gchar *file_name,gchar *list);
gchar* internal_create_list_file	(gchar *list);
gchar* extract_file_from_archive	(gchar *arcname,gchar *file_name);
void extract_single				(void);
gboolean extract_to_path		(gchar *file_name, gchar *path, gchar *files);

gboolean test_archive (gchar *file_name);
void quick_test				(void);

void
display_comments		(GtkWidget *widget);

void
convert_arch				(gchar *type);

gint gnochive_check_arch_update (gchar *file_name);

gboolean gnochive_close_archive(archivedesc *ad);

void read_pwd_files(char *pwd);

gboolean is_archive(gchar *file_name);
void test_encrypted_archive(gchar *arc_name);

void remove_activity(guint time);
guint set_activity(void);
guint explode_archive(GtkCList *clist, guint vline, 
				gchar *rbase, gchar *clist_line[9]);
void archive_cd(GtkWidget *widget, gchar *path);
gint gnochive_add_archive_files(archivedesc *ad, gchar *file);
void gnochive_arch_file_view(void);
void gnochive_file_open_internal(gchar *file);
void show_props (archivedesc *ad);

#ifdef __cplusplus
}
#endif

#endif
