/*  GUI frontend for common compresion programs
 *  Copyright 2000-2001  Lucian Langa
 *
 *	gnochive configure engine
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _GC_SETUP_H_
#define _GC_SETUP_H_


typedef struct _paths paths;
typedef struct _gnochive_config gnochive_config;

	
struct _paths
{
	gchar *rar_path;
	gchar *gzip_path;
	gchar *tar_path;
	gchar *zip_path;
	gchar *unzip_path;
	gchar *bz2_path;
	gchar *Z_path;
	gchar *unarj_path;
	gchar *unace_path;
	gchar *lha_path;
	gchar *zoo_path;
	gchar *rpm_path;
	gchar *cpio_path;
	gchar *rpm2cpio_path;
};

struct _gnochive_config
{
	GtkWidget *widget;
	gchar *file_name;
	paths archs;
	gboolean tit;
	gboolean res_syms;
	gboolean popn;
	guint		gbstat;		//button style
	guint 		tstyle;		//text stye
	guint 		tbstyle;		//tabs position
	gboolean 	stype;
	gchar 		*workdir;
	gboolean 	bz2flag;
	gchar 		*tbz2parm;
	gboolean 	internal;
	guint		cclist_val;
	gboolean overwrite;		//extract since we don't have an archive descriptor from the begining
	gboolean all;
	gboolean defaults;
	gboolean complete;
	gboolean rpm_handle;	// 0 for dummy, 1 for rpm filesystem
	gboolean main_visible;
	gboolean location_visible;
	gboolean archive_visible;
};
	
extern gnochive_config *gc_config;

gnochive_config* config_gnochive			(void);

gnochive_config* create_cfile(gchar *cfg_file);
gnochive_config* read_cfile(gchar *cfgbuff);
gchar* read_arcline(gnochive_config *var,gchar *cfgbuff);
gchar* parse_option (gnochive_config *var,gchar *cfgbuff);
gchar* get_local_cfile(void);
gchar* detect_arc_def_path(gchar *arc_name,FILE *cfgfile);
int find_arc(gchar *arc);
gchar* write_parse_arc_path(gchar *path,FILE *cfgfile);
void write_scripts(void);
void remove_scripts(void);
gboolean create_script(gchar *sfile,gchar *dtafile);

#endif
