/*  GUI frontend for common compression programs
 *  Copyright 2000-2001  Lucian Langa
 *
 *  This progronam is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distopen_ributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICUrLAR PURPOSE.  See the
 *  GNU General Public License for more dentails.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "gnochive.h"
#include "interface.h"
#include "support.h"

/*gnochive libs*/
#include "gc_bk_end.h"
#include "gc_setup.h"
#include "components.h"
#include "mime.h"
#include "gnomedirlist.h"
#include "rpm.h"

#include <error.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <pwd.h>
#include <fcntl.h>
#include <math.h>

#define MAXSTR 255
#define TIMEOUT_GTK 5

#include "conf.h"

#define SHARE_DIR ""
#define CONFIG_FILE "~/.gnochive"

// last byte for cut & paste menu

#define SINGLE_MENU 0x15007F
#define MULTI_MENU 0x1AF07F
#define A_FILES_MENU 0x6FF
#define DECOMP_MENU 0xCFF
#define PLAIN_TAR_MENU 0x1504FF

#define DECOMP_WV_MENU 0x6FF

gchivemain *gnochivemain;
archivedesc *my_ad;

extern gint errno;

GnomeApp *myapp;
GtkWidget *mainwidget;
// My Gtk Widgets
GtkWidget *open3;
GtkWidget *open4;
GtkWidget *mainwindow;
GtkWidget *clist2;
GtkWidget *dock1;
GtkWidget *dock3;
GtkWidget *dialog1;
GtkWidget *dialog11;
GtkWidget *window1;
GtkWidget *compress_estimate;
GtkWidget *dialog5;
GtkWidget *quick_pack;
GtkWidget *text1;
GtkWidget *entry1;
GtkWidget *entry6;
GtkWidget *combo1;
GtkWidget *archive_passwd;
GtkWidget *pathwin;
GtkWidget *arcmenu1;

GtkItemFactory *mypopup_fl;
GtkItemFactory *mypopup1;

GtkWidget *button7;
GtkWidget *s_ext;

char q_ext[10];		// quick pack extension
gchar qname[0x100];

int sel_mode=0;

FILE *tempfile; //used for temporary open files

gnochive_config *gc_cfg;

int opd_archive=1;
gchar *newarch;
gchar *name[0x100];
guint textlen;
int line,row;
int myargc;
char *myargv[10];

char buff[0x100];
gchar *clist1_line[1][3];
int i,j=0,q,p;
char current_opd_archive[0x200];
int current_lines=0;
gchar *selected_rows;
int nrows=0;
int select_all=0;
gchar *sel_files;
int total_sel_size=0;

int last_select_row;
int last_select_column;

int last_unselect_row=0;
int implicit_sel;
int testdbl=0;
float progr=0;
gchar *directory_read = ".";
gchar *directory_up = "..";
char lck[4]="lock";
struct stat statbuf;

char nicexfr[0x100];
gchar sfx_path[0x100];
gchar *vol_size;
int vol_change=0;
gchar *arc_type;
int sel_filter=0;	// tar filter 0 - none 1 - gzip 2 - bzip2 3 - compress 4 - custom
gchar custom_filter[0x100];
gchar *compression_level;
gchar *dictionary_size;
gchar comp_command[0x20];
gchar dict_command[0x20];
int pass_locked_arch=0;
int create_locked_arch=0;
gchar *arch_pass;
gchar pass_command[0x30];
gchar no_pass_command[0x30]="-p-";
gchar *create_arch_pass;
gchar cur_dir[0x100];
int endpos;

guint time_id;

gfloat step;
int stepping;
GnomeAppProgressKey key;

gboolean ALT_DOWN = FALSE;

gchar estm_type[4]="RAR";

gint totalsize=0;
gint totalpck=0;
gfloat totalratio=0;

GdkPixmap 	*dirpix,*docpix,*dotpix;
GdkBitmap 	*dirmask,*docmask,*dotmask;

	GtkWidget *wdentry;
	GtkWidget *nbutton;		// nautilus parsed path button
	gboolean wdstate=FALSE;

/* archive right menu -for single selection */
static GtkItemFactoryEntry mypopup1_items[] =
	{
	{"/extract selected file(s)",	NULL, (GtkSignalFunc)extract_to,		0},
	{"/Repack",			NULL,	(GtkSignalFunc)extract_to,		0},
	{"/sep0",			NULL,			NULL,		0,"<Separator>"},
	{"/Test archive",			NULL, (GtkSignalFunc)quick_test,	0},
	{"/sep0",			NULL,			NULL,		0,"<Separator>"},
	{"/Select all",			NULL, (GtkSignalFunc)myfnc_sel,		0},
	{"/Un-Select all",		NULL, (GtkSignalFunc)myfnc_unsel,	0},
	{"/sep0",			NULL,			NULL,		0,"<Separator>"},
	{"/Copy",			NULL, 			NULL,		0},
	{"/Properties",			NULL, (GtkSignalFunc)show_props,	0}};

//static guint mytime(gpointer data);
//static void gnome_dirlist_destroy(GtkObject *object);

	guint srw;
	
#include "archs.h"

#include "rar.h"
	
#include "gzip.h"
#include "lha.h"
#include "bzip2.h"

MainMenu *menu;
	
void
on_new_file1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
dialog1=create_create_archive();
gtk_widget_show(dialog1);
}

void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
remove("/tmp/gnochive.pid");
remove("/tmp/gcparse");
remove_scripts();
gtk_main_quit();
}


void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_clear1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
int i;
for (i=0;i<gnochivemain->active_page->current_lines;i++) {
	if (gnochivemain->active_page->selected_rows[i] == 1
		&& i!=0 && i!=1) 
			gtk_clist_unselect_row(GTK_CLIST(gnochivemain->active_page->clist), i, 0);
	if (select_all == 1) 
			gtk_clist_unselect_row(GTK_CLIST(gnochivemain->active_page->clist), i, 0);
}
select_all=0;
}

void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *notebook;
	notebook = lookup_widget(GTK_WIDGET(gnochivemain->gc_cfg->widget), "notebook7");
	if (user_data != NULL)
		gtk_notebook_set_page(GTK_NOTEBOOK(notebook), (gint) user_data);
	gtk_widget_show(gnochivemain->gc_cfg->widget);
	
}

void
on_homepage_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if (user_data)
		gnome_url_show(user_data);
}

void
on_report_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if (user_data)
		gnome_url_show(user_data);
}


void
on_about2_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *about3=create_about3();
	gtk_widget_show(about3);
}

void
corrupt_arch(void)
{
	GtkWidget *box1;
	
	box1=gnome_message_box_new(_("Unknown archive or file corrupted!"),GNOME_MESSAGE_BOX_ERROR,"OK",NULL);
	gnome_dialog_run(GNOME_DIALOG(box1));
	gnochivemain->active_page->opd_archive=FALSE;
}

void
on_button13_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
remove("/tmp/gnochive.pid");
	remove("/tmp/gcparse");
remove_scripts();
gtk_main_quit();
}

void
on_button9_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *path = g_get_current_dir();
	gchar *text = NULL;
	gchar *full_path = NULL;
	gchar *ac_type = NULL;
	
	if (!gnochivemain->active_page->opd_archive) 
	{
		gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist),
						last_select_row, 1, &text);
		if (text != NULL)
		{
			full_path = g_concat_dir_and_file(path, text);
			ac_type = gnochive_get_archive_type(full_path);
			if (ac_type)
			{
				extract_to(NULL, text);
				g_free(ac_type);
			}
			g_free(full_path);
		}
	}
	else
		extract_to(NULL, gnochivemain->active_page->ad->full_name);
	g_free(path);
}


void
on_clist1_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	int in_sel = 0;
	gchar *text = NULL;
	gchar *buff = NULL;
	GtkWidget *toolbar;
	GtkWidget *ext_butt;
	gchar *ac_type;
	gchar *cur_dir = NULL;
	gfloat ratioprogress;
	
	if (select_all == 1) {
		    gtk_clist_unselect_row(GTK_CLIST(clist), 0, 0);
		    gtk_clist_unselect_row(GTK_CLIST(clist), 1, 0);
		    return;
	}
	if (testdbl == 2) {
		gtk_clist_unselect_row(clist, row, 0);
		gtk_clist_get_text(GTK_CLIST(clist), row, 1, &text);
		chdir(text);
		cur_dir = g_get_current_dir();
		gnochive_read_pwd_files(cur_dir);
		g_free(cur_dir);
		last_select_row = 0;
		gnochivemain->active_page->files_selected = 0;
		total_sel_size = 0;
		g_free(gnochivemain->active_page->selected_rows);
		gnochivemain->active_page->selected_rows = 
					g_malloc0(gnochivemain->active_page->current_lines);
		gnome_appbar_clear_stack(GNOME_APPBAR(gnochivemain->mainbar));
		testdbl = 0;
		return;
		}
if (gnochivemain->active_page->opd_archive) {
    if (	row != 1 
		 && row != 0
		 && row <= gnochivemain->active_page->current_lines)
	{
		gnochivemain->active_page->selected_rows[row]=1;
		gnochivemain->active_page->files_selected++;
		gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist), row, 8, &text);
		if (text != NULL) {
			ratioprogress = (atof(text)/100);
			gnome_appbar_set_progress(GNOME_APPBAR(gnochivemain->mainbar),
						ratioprogress);
		}
		gnome_appbar_pop(GNOME_APPBAR(gnochivemain->mainbar));
		buff = g_strdup_printf(_("Files selected: %d"), 
						gnochivemain->active_page->files_selected);
		gnome_appbar_push(GNOME_APPBAR(gnochivemain->mainbar), buff);
		g_free(buff);
		/*gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist),row,3,&text);
		total_sel_size=total_sel_size+atoi(text);*/
	}
    if (!row) {
		refresh_arch(gnochivemain->active_page->ad);
		gtk_clist_unselect_all(GTK_CLIST(clist));
		//gtk_clist_unselect_row(GTK_CLIST(clist), 0, 0);
		//gtk_clist_select_row(GTK_CLIST(clist), 2, 2);
		gnome_appbar_clear_stack(GNOME_APPBAR(gnochivemain->mainbar));
		j = implicit_sel;
		total_sel_size = 0;	// reset size of selected files
		if (testdbl)
			gnome_appbar_set_progress(GNOME_APPBAR(gnochivemain->mainbar), 0);
    }
}
else {
	if (row != 0 &&
		row != 1 &&
		row <= gnochivemain->active_page->current_lines)
	{
	    gnochivemain->active_page->selected_rows[row] = 1;
	    nrows++;
		gnochivemain->active_page->files_selected++;
		gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist), row, 1, &text);
		toolbar = lookup_widget(GTK_WIDGET(gnochivemain->mainwin), "toolbar1");
		ext_butt = lookup_widget(GTK_WIDGET(toolbar), "button9");
		/*FIXME checks for read permissions on archive*/
		if (!is_dir(text))
		{
			ac_type = gnochive_get_archive_type(text);
			if (ac_type>0)
			{
				if (ac_type)
				{
					gtk_widget_set_sensitive(GTK_WIDGET(ext_butt), TRUE);
					ext_butt = lookup_widget(GTK_WIDGET(toolbar), "button10");
					gtk_widget_set_sensitive(GTK_WIDGET(ext_butt), TRUE);
				}
				else
				{
					gtk_widget_set_sensitive(GTK_WIDGET(ext_butt), FALSE);
					ext_butt = lookup_widget(GTK_WIDGET(toolbar), "button10");
					gtk_widget_set_sensitive(GTK_WIDGET(ext_butt), FALSE);
				}
			}
			else
				gnome_app_flash(GNOME_APP(gnochivemain->mainwin), _("Cannot read file!"));
		}
	}
	/*gnome_appbar_pop(GNOME_APPBAR(gnochivemain->mainbar));
	if (files_selected!=0) {
		buff=g_strdup_printf(_("Files selected: %d"),files_selected);
		gnome_appbar_push(GNOME_APPBAR(gnochivemain->mainbar),buff);
		g_free(buff);
	}
	else gnome_appbar_clear_stack(GNOME_APPBAR(gnochivemain->mainbar));*/
}
in_sel = 0;
last_select_row = row;
}

void
on_close1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if (gnochivemain->active_page->opd_archive)
	{
		gnochive_close_archive(gnochivemain->active_page->ad);
		last_select_row=0;
		gnochivemain->active_page->files_selected = 0;
	}
}


void
on_button17_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_show(gnochivemain->gc_cfg->widget);
}


void
on_clist1_select_all                   (GtkCList        *clist,
                                        gpointer         user_data)
{
select_all=1;
}


void
on_clist1_unselect_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	gchar *buff = NULL;
	
	if (row != 0 && row != 1)
		gnochivemain->active_page->selected_rows[row] = 0;
	if (gnochivemain->active_page->files_selected != 0)
		gnochivemain->active_page->files_selected--;
	buff = g_strdup_printf(_("Files selected: %d"), gnochivemain->active_page->files_selected);
	gnome_appbar_clear_stack(GNOME_APPBAR(gnochivemain->mainbar));
	if (gnochivemain->active_page->files_selected != 0)
		gnome_appbar_push(GNOME_APPBAR(gnochivemain->mainbar), buff);
	g_free(buff);
	last_unselect_row = row;
}


void
on_button7_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *opt_menu;
	GtkWidget *flt_menu;
	GtkWidget *menu;
	GtkWidget *submenu;
	
	my_ad = (archivedesc *)g_malloc0(sizeof(archivedesc));
	
	dialog1 = create_create_archive();
	opt_menu = lookup_widget(GTK_WIDGET(dialog1), "optionmenu1");
	menu = create_arch_menu();
	flt_menu = lookup_widget(GTK_WIDGET(dialog1), "optionmenu2");
	submenu = create_subarch_menu();
	
	gtk_option_menu_set_menu(GTK_OPTION_MENU(opt_menu), menu);
	gtk_option_menu_set_menu(GTK_OPTION_MENU(flt_menu), submenu);
	
	if (my_ad)
	{
		/*some defaults shit*/
		my_ad->locked = FALSE;
		my_ad->dict_size = g_strdup("-md256");
		my_ad->volume = 0;
		my_ad->compress_level = g_strdup("-5");
		my_ad->type="tar";
		my_ad->sub_type=1;
	}
	gtk_widget_show(dialog1);
}


void
on_button21_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	gboolean res = FALSE;
	gchar *newname = NULL;
	GtkWidget *ent = lookup_widget((GtkWidget *)button, "combo_entry25");
	GtkWidget *pass_ent = lookup_widget((GtkWidget *)button, "entry58");
	
	my_ad->name = g_strdup(gtk_entry_get_text(GTK_ENTRY(ent)));
	my_ad->passwd = g_strdup(gtk_entry_get_text(GTK_ENTRY(pass_ent)));
	if (!strlen(my_ad->passwd))
		my_ad->locked = FALSE;
	
	if (strlen(my_ad->name) != 0 && nrows != 0) {
		res = create_archive(my_ad);
		if (res) {
			gnome_app_flash(GNOME_APP(gnochivemain->mainwin), _("Sucessfully created archive."));
			if (gnochivemain->gc_cfg->popn)
			{
				newname = g_strdup(my_ad->full_name);
				my_ad = open_real_archive(newname);
				g_free(newname);
			}
			else refresh_dir(".");
		}
	}
	gtk_widget_destroy(dialog1);
	gtk_clist_unselect_row(GTK_CLIST(gnochivemain->active_page->clist),0,0);
}

void
on_button22_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(dialog1);
}


void
on_clist1_unselect_all                 (GtkCList        *clist,
                                        gpointer         user_data)
{
g_print("do an unselect");
}

void
on_app1_set_focus                      (GtkWindow       *window,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{
//progressbar1=user_data;
}

void
on_app1_destroy                        (GtkObject       *object,
                                        gpointer         user_data)
{
// if archive is still open and didn`t get close signal
remove("/tmp/gnochive.pid");
	remove("/tmp/gcparse");
gtk_main_quit();
}

void
on_app1_show                           (GtkWidget       *widget,
                                        gpointer         user_data)
{
	
		mainwidget=widget;
				
		dig_items(widget);
		create_right_menus();
		sel_files=0;		
			
		write_scripts();
			
		/*Setting default dictionary size */
		strcpy(dict_command,"-md");
		strcat(dict_command,"256");
		/*Setting default compresion method (normal)*/
		strcpy(comp_command,"-m");
		strcat(comp_command,"3");
		prepare_arc_menu();
		//init_gnome_progress();
		
}


void on_gcopen_func(GtkButton *button, gpointer data)
{
	gchar *myfile=NULL;
	myfile=gnome_filelist_get_filename (GNOME_FILELIST(gnochivemain->op_filesel));
	if (!myfile) return;
	if (is_regular(myfile) == FALSE)
	{	
		gnochive_error(errno,_("%s is not a regular file!\n"),myfile);
		g_free(myfile);
		return;
	}
	if (is_readable(myfile) == FALSE)
	{
		gnochive_error(errno,_("Cannot read %s !\n"),myfile);
		g_free(myfile);
		return;
	}
	(void *)open_real_archive(myfile);
	g_free(myfile);
}

void on_dir_sel(GtkButton *button, gpointer data)
{
	gchar *dir=NULL;
	gchar *error=NULL;
	
	dir = gnome_dirlist_get_dir (GNOME_DIRLIST(gnochivemain->dirsel));
	gtk_widget_hide (gnochivemain->dirsel);
	if (gnochivemain->dirparent==gnochivemain->location_entry)
	{
		if (chdir(dir)==0) {
			gtk_entry_set_text(GTK_ENTRY(gnochivemain->dirparent),dir);
			if (gnochivemain->active_page->opd_archive)
				gnochive_close_archive(gnochivemain->active_page->ad);
			gtk_clist_clear(GTK_CLIST(gnochivemain->active_page->clist));
			read_pwd_files(".");
			g_free(gnochivemain->active_page->selected_rows);
			gnochivemain->active_page->selected_rows = g_malloc0(gnochivemain->active_page->current_lines);
		} else {
			error = g_strconcat(_("Cannot change directory to "), dir, " :Permission denied!", NULL);
			gnome_app_flash(GNOME_APP(gnochivemain->mainwin),error);
			g_free(error);
		}
	} else gtk_entry_set_text(GTK_ENTRY(gnochivemain->dirparent),dir);
	g_free (dir);
}

void
dig_items				(GtkWidget *widget)
{
	mainwindow = lookup_widget(GTK_WIDGET(widget), "gnochive");
	dock1 = lookup_widget(GTK_WIDGET(widget), "dock1");
	dock3 = lookup_widget(GTK_WIDGET(widget), "toolbar1");
	entry6 = lookup_widget(GTK_WIDGET(widget), "combo_entry4");
	arcmenu1 = lookup_widget(GTK_WIDGET(widget), "combo_entry18");
}


void
gnochive_init	(GtkWidget *mainwin)
{
	gchar *tempfiles = NULL;
	
	gnochivemain = (gchivemain *)g_malloc(sizeof(gchivemain));
	menu = (MainMenu *)g_malloc(sizeof(MainMenu));
	
	if (gnochivemain)
	{
		static FileSelData fs1 = { N_("Open Archive"), NULL, on_gcopen_func,
									cancel_fs_func, NULL};
		static FileSelData fs2 = { N_("Save File"), NULL, myfn,
									cancel_fs_func, NULL};		//FIXME
									
		static DirSelData ds1 = { N_("Select directory"), NULL, on_dir_sel,
									cancel_dir_func, NULL};
									
		gnochivemain->op_filesel = create_myfile_selection(&fs1);
		gnochivemain->sv_filesel = create_myfile_selection(&fs2);
		gnochivemain->dirsel = create_dir_selection(&ds1);
		gnochivemain->gc_cfg = config_gnochive();
		gnochivemain->app = GNOME_APP(mainwin);
		gnochive_attach_keys(GTK_OBJECT(mainwin));
		if (gnochivemain->gc_cfg->defaults) 
			gnome_app_flash(GNOME_APP(gnochivemain->app), 
					_("Configuration file not found , parsing defaults"));
		gnochivemain->mainwin = mainwidget;
		gnochivemain->location_entry = lookup_widget(GTK_WIDGET(mainwidget), "combo_entry4");
		gnochivemain->vport = lookup_widget(mainwidget, "viewport3");
		gnochivemain->mainbar = lookup_widget(mainwidget, "appbar1");
		create_main_menu(gnochivemain->app, menu);
		gnochivemain->menubar = menu;
		gnochivemain->mainmenu = create_folder_pack_menu();
		gnochivemain->noter = NULL;
		gnochivemain->gc_pager = gnochive_pager_init();
		gnochivemain->gc_pager->opd_archive = FALSE;
		gnochivemain->active_page = gnochivemain->gc_pager;
		gnochivemain->gc_pager->next = (gpointer) NULL;
		gnochivemain->gc_cfg->widget = create_pobox3();
		gnochivemain->dnd = gnochive_drag_init();
		gnochivemain->log_window = create_log_window();
		
		gnochivemain->gc_cfg->main_visible = FALSE;
		gtk_check_menu_item_set_active((GtkCheckMenuItem *) gnochivemain->menubar->view.main_toolbar, TRUE);
		gnochivemain->gc_cfg->location_visible = FALSE;
		gtk_check_menu_item_set_active((GtkCheckMenuItem *) gnochivemain->menubar->view.location_toolbar, TRUE);
		gnochivemain->gc_cfg->archive_visible = FALSE;
		gtk_check_menu_item_set_active((GtkCheckMenuItem *) gnochivemain->menubar->view.archive_toolbar, TRUE);
		update_main_menu(menu);
	}
	/*get rid of temporary files */
	tempfiles = g_concat_dir_and_file(TMPDIR,"gchive*");
	remove(tempfiles);
	g_free(tempfiles);
	tempfiles = g_concat_dir_and_file(TMPDIR,"gchive.*");
	remove(tempfiles);
	g_free(tempfiles);
}

void
normal_startup				(GtkWidget *mainwin)
{
	gchar *cur_dir = g_get_current_dir();
	
	gnochive_init(mainwin);
	gnochive_read_pwd_files(g_get_current_dir());
	gnochivemain->gc_pager->selected_rows = g_malloc0(gnochivemain->gc_pager->current_lines);
	gtk_entry_set_text(GTK_ENTRY(entry6),cur_dir);
	g_free(cur_dir);
}

void
process_archive				(GtkWidget *mainwin,gchar *argarc[])
{
	gint i;
	gnochive_init(mainwin);
	gtk_clist_clear(GTK_CLIST(gnochivemain->gc_pager->clist));
	read_pwd_files(".");
	gnochivemain->gc_pager->selected_rows = g_malloc0(gnochivemain->gc_pager->current_lines);
	for (i=0;argarc[i]!=NULL;i++)
		open_archive(argarc[i]);
}

/* internal function use open_real_archive instead */
gboolean
open_archive				(gchar *archive)
{
	gchar *msg = NULL;
	GtkWidget *dialog;
	
	if (!is_readable(archive))
	{
		gnochive_error(errno,_("Could not open archive: %s !\n"),archive);
		return FALSE;
	}
	else
	{
		chdir((char *)get_parent_directory(archive));
		if (open_real_archive(archive)) {
			msg = g_strdup_printf(_("Processing archive %s"), archive);
			gnome_app_flash(GNOME_APP(gnochivemain->mainwin), msg);
			g_free(msg);
			return TRUE;
		}
		else {
			msg = g_strdup_printf(_("Could not open archive %s !"), archive);
			dialog = gnome_message_box_new(msg, GNOME_MESSAGE_BOX_ERROR, _("OK"), NULL);
			gnome_dialog_run_and_close(GNOME_DIALOG(dialog));
			g_free(msg);
			return FALSE;
		}
	}
}

/* type 0 for relative path
   type 1 for absolute path
   type 2 for relative archive path
   type 3 for absolute archive path
 */
 
void
update_main				(gchar *file_name, gboolean type)
{
	gchar *temp = NULL;
	gchar *myfile;
	gchar *title;
	
if (!type || type == 2)
 {
    temp = g_strdup(gtk_entry_get_text(GTK_ENTRY(entry6)));
	if (temp[0]==G_DIR_SEPARATOR && strlen(temp)==1)
		myfile = g_strconcat(temp,file_name,NULL);
    else
		myfile = g_strconcat(temp,G_DIR_SEPARATOR_S,file_name,NULL);

 }
else
 myfile = g_strdup(file_name);
gtk_entry_set_text(GTK_ENTRY(entry6), myfile);
if (type >= 2)
	gtk_widget_set_sensitive(GTK_WIDGET(entry6), FALSE);
else 
	gtk_widget_set_sensitive(GTK_WIDGET(entry6), TRUE);
g_free(temp);
title = g_strdup_printf(_("%s: %s"),GNOCHIVE_VER, myfile);
gtk_window_set_title(GTK_WINDOW(gnochivemain->mainwin), title);
g_free(myfile);
g_free(title);
}

void
on_button11_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	if (gnochivemain->active_page->opd_archive)
		gnochive_arch_file_view();
}

void
on_window1_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
//free(vwfile);			// free my file reading buffers
}


void
on_button12_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *box;
	gchar *root;
	gint depth;
		
if (!gnochivemain->active_page->opd_archive)
{
	box = gnome_message_box_new(_("No opened archive!\nor selected file is a known archive!"),GNOME_MESSAGE_BOX_ERROR,"OK",NULL);
	gnome_dialog_run(GNOME_DIALOG(box));
}
else {
	delete_arc_file(gnochivemain->active_page->ad);
	root = g_strdup(gnochivemain->active_page->ad->root);
	depth = gnochivemain->active_page->ad->depth;
	refresh_arch(gnochivemain->active_page->ad);
	gnochivemain->active_page->ad->depth = depth;
	archive_cd(gnochivemain->active_page->clist, root);
	gnome_appbar_pop(GNOME_APPBAR(gnochivemain->mainbar));
	gnome_appbar_set_progress(GNOME_APPBAR(gnochivemain->mainbar),0);
	}
}

/*
 * refreshes current directory
 * (dir should be alwayz "." directory unless you know what yo're doing)
 * @clist1,current_lines,selected_rows shoud be global values
 * 
 */

void
refresh_dir			(gchar *dir)
{
	gchar *cur_dir = NULL;
	gtk_clist_clear(GTK_CLIST(gnochivemain->active_page->clist));
	if (dir[0] == '.')
	{
		cur_dir = g_get_current_dir();
		gnochive_read_pwd_files(cur_dir);
		g_free(cur_dir);
	}
	else
		gnochive_read_pwd_files(dir);
	g_free(gnochivemain->active_page->selected_rows);
	gnochivemain->active_page->selected_rows = 
			g_malloc0(gnochivemain->active_page->current_lines);
}

void
on_ok_button2_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
newarch = gtk_file_selection_get_filename(GTK_FILE_SELECTION(user_data));
gtk_entry_set_text(GTK_ENTRY(entry1),newarch);
gtk_widget_destroy(open3);
}

void
on_button24_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
entry1=user_data;
open3=create_fileselection2();
gtk_widget_show(open3);

}


void
on_select_all1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
gtk_clist_select_all(GTK_CLIST(gnochivemain->active_page->clist));
}

gchar*
parse_direct		(gint j)
{
	gchar *cfgbuff=NULL;
	gchar opt[0x100];
	gchar *ret;
	gint i=0;

	while(cfgbuff[j]!='=') j++;
j++;
while(cfgbuff[j]!='\n')
{
 opt[i]=cfgbuff[j];
 i++;j++;
}
opt[i]='\0';
(gchar *)ret=opt;
g_print ("%s",opt);
return ret;
}

void
on_selected_file1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gnochive_arch_file_view();
}

gchar*
view_normal_file			(gchar *file_name)
{
gchar *myfile;
gint viewsize;
tempfile=fopen(file_name,"r");
fseek(tempfile,0L,SEEK_END);
viewsize=ftell(tempfile);
myfile=g_malloc0(viewsize);
fseek(tempfile,0L,SEEK_SET);
fread(myfile,1,viewsize-1,tempfile);
fclose(tempfile);
return myfile;
}

void
on_test_archive1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	quick_test();
}


void
on_add_comment1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

int
test_inserted(int list_size,gchar *myword)
{
int is_inserted=0;
int i;
gchar *text="\0";
for (i=0;i<list_size;i++) {
			    gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist), i, 1, &text);
			    if (strcmp(text,myword)==0) is_inserted=1;
			    }
return is_inserted;
}

/* global var endpos will return the posistion where the s2 finish in s1 */

int
cmpare(gchar *s1,gchar *s2)
{
int pos1=0,pos2=0;
int mycmp=-1;
int vfon=0;
endpos=0;
while (s1[pos1]!='\0'){
			if (s1[pos1]==s2[pos2]) { pos1++;pos2++;vfon=1;}
			else {if (vfon==0) {
					    pos1++;
					    pos2=0;
					}
				if (vfon==1) {
						pos1++;pos2=0;
						vfon=0;
						}
				}
			if (s2[pos2]=='\0') {endpos=pos1;mycmp=0;} //s2[pos2]
			}
pos1=0;
pos2=0;
return mycmp;
}

void
on_button10_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	quick_test();
}

void
on_ok_button3_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
GtkWidget *terror;
gchar *text;
text=gtk_file_selection_get_filename(GTK_FILE_SELECTION(user_data));
strcpy(nicexfr,text);
gtk_widget_destroy(open4);
if (cmpare(nicexfr,".tar")!=0 || endpos!=strlen(nicexfr)) test_archive(nicexfr);
else {
	terror=gnome_message_box_new(_("Plain tar and tar.Z archives cannot be tested!"),GNOME_MESSAGE_BOX_INFO,"OK",NULL);
	gnome_dialog_run(GNOME_DIALOG(terror));
    }
}



void
on_cancel_button3_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(open4);
}

void
on_fileselection3_destroy              (GtkObject       *object,
                                        gpointer         user_data)
{
gtk_widget_destroy(open4);
}


void
on_button19_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *mygtktext = NULL;
	FILE *commfile;
	gchar *temp_name;
	int tf;
	guint textlen;
	gchar *cfile;
	GtkWidget *text1;
	
	if 	((gnochivemain->active_page->opd_archive)
		&& (cmpare(gnochivemain->active_page->ad->type, "RAR")==0 
			|| cmpare(gnochivemain->active_page->ad->type, "zip")==0
			|| cmpare(gnochivemain->active_page->ad->type, "zoo")==0))
	{
		temp_name = g_concat_dir_and_file(TMPDIR, "gchiveXXXXXX");
		tf = mkstemp(temp_name);
		close(tf);
		
		text1 = lookup_widget(GTK_WIDGET(gnochivemain->gc_cfg->widget), "text4");
		
		if ((textlen = gtk_text_get_length(GTK_TEXT(text1)))!=0)
		{
			mygtktext = gtk_editable_get_chars((GtkEditable *)text1, 0, textlen);
			commfile = fopen(temp_name, "w+");
			fwrite(mygtktext, textlen, 1, commfile);
			fclose(commfile);
			if (cmpare(gnochivemain->active_page->ad->type, "RAR")==0)
			{
				cfile = g_strconcat("-z", temp_name, NULL);
				gnochive_exec_arch(gnochivemain->gc_cfg->archs.rar_path,
					"rar", "-inul", "-o+", "-y", "c", cfile,
					gnochivemain->active_page->ad->full_name, 0);
				g_free(cfile);
			}
			if (cmpare(gnochivemain->active_page->ad->type, "zip")==0)
			{
				gnochive_exec_arch("/tmp/zpps", "zpps", 
					gnochivemain->gc_cfg->archs.zip_path, "-q", "-z",
					gnochivemain->active_page->ad->full_name, temp_name, NULL);
			}
			if (cmpare(gnochivemain->active_page->ad->type, "zoo")==0)
			{
				gnochive_exec_arch("/tmp/zpps", "zpps", "nice", 
					gnochivemain->gc_cfg->archs.zoo_path,
					"cA", gnochivemain->active_page->ad->full_name, temp_name, NULL);
			}
			wait(0);
		}
		else
		{
			gnochive_exec_arch(gnochivemain->gc_cfg->archs.rar_path,
				"rar", "-inul", "-o+", "-y", "c", "-z/dev/null",
				gnochivemain->active_page->ad->full_name, 0);
			wait(0);
		}
		remove(temp_name);
		g_free(temp_name);
	}
}


void
on_button20_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	guint textlen;
	GtkWidget *text1;
	
	text1 = lookup_widget (GTK_WIDGET(gnochivemain->gc_cfg->widget), "text4");
	textlen = gtk_text_get_length(GTK_TEXT(text1));
	gtk_text_set_point(GTK_TEXT(text1), 0);
	gtk_text_forward_delete(GTK_TEXT(text1), textlen);
}

void
on_button7_enter                       (GtkButton       *button,
                                        gpointer         user_data)
{
	gnome_appbar_push(GNOME_APPBAR(gnochivemain->mainbar),_("Create/Add files to archive"));
}


void
on_button7_leave                       (GtkButton       *button,
                                        gpointer         user_data)
{
	gnome_appbar_pop(GNOME_APPBAR(gnochivemain->mainbar));
}

void
on_button8_enter                       (GtkButton       *button,
                                        gpointer         user_data)
{
	gnome_appbar_push(GNOME_APPBAR(gnochivemain->mainbar),_("Open archive"));
}


void
on_button8_leave                       (GtkButton       *button,
                                        gpointer         user_data)
{
	gnome_appbar_pop(GNOME_APPBAR(gnochivemain->mainbar));
}


void
on_button9_enter                       (GtkButton       *button,
                                        gpointer         user_data)
{
gnome_appbar_push(GNOME_APPBAR(gnochivemain->mainbar),
	_("Extract files from archive to current path"));
}


void
on_button9_leave                       (GtkButton       *button,
                                        gpointer         user_data)
{
gnome_appbar_pop(GNOME_APPBAR(gnochivemain->mainbar));
}


void
on_button10_enter                      (GtkButton       *button,
                                        gpointer         user_data)
{
	gnome_appbar_push(GNOME_APPBAR(gnochivemain->mainbar),
		_("Test archive integrity"));
}


void
on_button10_leave                      (GtkButton       *button,
                                        gpointer         user_data)
{
	gnome_appbar_pop(GNOME_APPBAR(gnochivemain->mainbar));
}


void
on_button11_enter                      (GtkButton       *button,
                                        gpointer         user_data)
{
	gnome_appbar_push(GNOME_APPBAR(gnochivemain->mainbar),_("View selected file"));
}


void
on_button11_leave                      (GtkButton       *button,
                                        gpointer         user_data)
{
	gnome_appbar_pop(GNOME_APPBAR(gnochivemain->mainbar));
}


void
on_button12_enter                      (GtkButton       *button,
                                        gpointer         user_data)
{
	gnome_appbar_push(GNOME_APPBAR(gnochivemain->mainbar),_("Delete selected files from archive"));
}


void
on_button12_leave                      (GtkButton       *button,
                                        gpointer         user_data)
{
	gnome_appbar_pop(GNOME_APPBAR(gnochivemain->mainbar));
}


void
on_button17_enter                      (GtkButton       *button,
                                        gpointer         user_data)
{
	gnome_appbar_push(GNOME_APPBAR(gnochivemain->mainbar),
		_("Archive options: Add/Remove Comments, Convert to SFX, Put auth info"));
}


void
on_button17_leave                      (GtkButton       *button,
                                        gpointer         user_data)
{
	gnome_appbar_pop(GNOME_APPBAR(gnochivemain->mainbar));
}


void
on_button18_enter                      (GtkButton       *button,
                                        gpointer         user_data)
{
gnome_appbar_push(GNOME_APPBAR(gnochivemain->mainbar),_("gnochive help"));
}


void
on_button18_leave                      (GtkButton       *button,
                                        gpointer         user_data)
{
	gnome_appbar_pop(GNOME_APPBAR(gnochivemain->mainbar));
}


void
on_button13_enter                      (GtkButton       *button,
                                        gpointer         user_data)
{
	gnome_appbar_push(GNOME_APPBAR(gnochivemain->mainbar),_("Quit gnochive"));
}


void
on_button13_leave                      (GtkButton       *button,
                                        gpointer         user_data)
{
	gnome_appbar_pop(GNOME_APPBAR(gnochivemain->mainbar));
}


void
on_checkbutton14_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	gchar sfxname[0x100];
	gchar def_path[0x100];
	FILE *sfx,*dsfx;
	int sfxsize;
	char *sfxfile;
	
p=0;
strcpy(sfxname,(gchar *)name);
while (sfxname[p]!='.')
{
 p++;
}
sfxname[p]='\0';
sfx=fopen(sfxname,"w+");
strcpy(sfx_path,def_path);
strcat(sfx_path,"/default.sfx");
if ((dsfx=fopen(sfx_path,"r"))==0) g_print("%s - not found",sfx_path);
fseek(dsfx,0L,SEEK_END);
sfxsize=ftell(dsfx);
sfxfile=malloc(sfxsize);
fseek(dsfx,0L,SEEK_SET);
fread(sfxfile,sfxsize,1,dsfx);
fclose(dsfx);
fwrite(sfxfile,sfxsize,1,sfx);
free(sfxfile);
if ((dsfx = fopen((char *)name, "r")) == 0)
	g_print("Archive file - not found");
fseek(dsfx,0L,SEEK_END);
sfxsize=ftell(dsfx);
sfxfile=malloc(sfxsize);
fseek(dsfx,0L,SEEK_SET);
fread(sfxfile,sfxsize,1,dsfx);
fclose(dsfx);
fwrite(sfxfile,sfxsize,1,sfx);
free(sfxfile);
fclose(sfx);
if (fork() == 0)
	execl("/bin/chmod", "chmod", "u+x", sfxname, 0);
g_snprintf(buff,90,_("Archive: %s converted to SFX. Written %s as binary file."), (char *)name, sfxname);
gnome_app_flash(GNOME_APP(mainwindow), buff);
}

void
on_combo_entry1_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
	guint vol[] = {362400, 730000, 1213800, 1457500, 2915200, 362400,
					730000, 1213800, 1457500, 2915200};
	gchar *vol_n[] = {"362400", "730000", "1213800", "1457500", "2915200",
					"360k - disk", "720k - disk", "1.2M - disk",
					"1.44M - disk", "2.88M - disk"};
	gchar *etext = gtk_entry_get_text((GtkEntry *)editable);
	guint i = 0;
	
	my_ad->vol_size = 0;
					
	while (i < 10 && my_ad->vol_size == 0)
	{
		if (!cmpare(vol_n[i], etext))
			my_ad->vol_size = vol[i];
		i++;
	}
	my_ad->volume = 1;
}



void
on_radiobutton1_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
GList *glist = NULL;
combo1 = user_data;
glist = g_list_append(glist, "362400");
glist = g_list_append(glist, "730000");
glist = g_list_append(glist, "1213800");
glist = g_list_append(glist, "1457500");
glist = g_list_append(glist, "2915200");
glist = g_list_append(glist, "Auto");
gtk_combo_set_popdown_strings(GTK_COMBO(combo1), glist);
}


void
on_radiobutton2_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
GList *glist=NULL;
combo1=user_data;
glist=g_list_append(glist,"360k - disk");
glist=g_list_append(glist,"720k - disk");
glist=g_list_append(glist,"1,2M - disk");
glist=g_list_append(glist,"1,44M - disk");
glist=g_list_append(glist,"2,88M - disk");
glist=g_list_append(glist,"Autodetect size");
gtk_combo_set_popdown_strings(GTK_COMBO(combo1),glist);
}


void
on_combo_entry2_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
	gchar *comp_level = gtk_entry_get_text((GtkEntry *)editable);
	if (my_ad->compress_level)
		g_free(my_ad->compress_level);
	if (!strcmp(comp_level,"Store")) 
		my_ad->compress_level = g_strdup("-1");
	if (!strcmp(comp_level,"Fastest"))
		my_ad->compress_level = g_strdup("-2");
	if (!strcmp(comp_level,"Fast"))
		my_ad->compress_level = g_strdup("-4");
	if (!strcmp(comp_level,"Normal"))
		my_ad->compress_level = g_strdup("-5");
	if (!strcmp(comp_level,"Good"))
		my_ad->compress_level = g_strdup("-7");
	if (!strcmp(comp_level,"Best"))
		my_ad->compress_level = g_strdup("-9");
}


void
on_combo_entry3_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
dictionary_size=gtk_entry_get_text((GtkEntry *)editable);
strcpy(dict_command,"-md");
strcat(dict_command,(gchar *)dictionary_size);
dict_command[strlen(dict_command)-1]='\0';
}


void
on_entry5_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
arch_pass=gtk_entry_get_text((GtkEntry *)editable);
strcpy(pass_command,"-p");
strcat(pass_command,(gchar *)arch_pass);
	g_print("pass:%s\n",arch_pass);
}


void
on_archive_passwd_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
gtk_widget_destroy(archive_passwd);
}


void
on_button37_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(archive_passwd);
}


void
on_button38_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(archive_passwd);
}

gboolean
on_clist1_button_press_event           (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
	gchar *text = NULL;
	gchar *myfile = NULL;
	gchar *temp = NULL;
	gchar *attr = NULL;
	gint   x, y = 0;
	gchar *gc_type, *vfs_type;
	gchar *tmpfile = NULL;
	gchar *rtxt = NULL;
	
	gtk_clist_get_selection_info (GTK_CLIST(widget),
						    event->x, 
						    event->y, 
						    &last_select_row, &last_select_column);
	
	gtk_clist_get_text(GTK_CLIST(widget), last_select_row, 1, &text);
	gtk_clist_get_text(GTK_CLIST(widget), last_select_row, 6, &attr);
	
	if (event->type == GDK_2BUTTON_PRESS) {
	if (!gnochivemain->active_page->opd_archive) {
		if (last_select_row != 0
			&& last_select_row != 1
			&& last_select_row <= gnochivemain->active_page->current_lines
		   )
		{
		    gtk_clist_get_text(GTK_CLIST(widget), last_select_row, 6, &text);
		    if (cmpare(text, "d") == 0) {
				gtk_clist_get_text(GTK_CLIST(widget), last_select_row, 1, &text);
				gtk_clist_unselect_row(GTK_CLIST(widget), last_select_row, 0);
				testdbl = 2; //dbl selection of a dir, or "." ".." dirs
				return TRUE;
			}
			else {
			gtk_clist_get_text(GTK_CLIST(widget), last_select_row, 1, &text);
			myfile = g_strdup(text);
			/* FIXME! optimize this a little bit */
			gc_type = gnochive_get_archive_type(myfile);
			vfs_type = gnochive_vfs_get_archive_type(myfile);
			g_print("Detected arc type: %s\n", gc_type);
			g_print("Detected mime type: %s\n", vfs_type);
			if (!gc_type && !vfs_type)
				gnochive_file_open_mime(myfile);
			else {
				open_real_archive(myfile);
				g_free(gc_type);
				g_free(vfs_type);
			}
			g_free(myfile);
			
			return TRUE;
			}
		}
		if ((last_select_row == 0 || last_select_row == 1) 
				&& (last_select_row <= gnochivemain->active_page->current_lines)) {
			gtk_clist_unselect_row(GTK_CLIST(widget),last_select_row,0);
			testdbl = 2;
			return TRUE;
		}
	}
	else
		if (last_select_row <= gnochivemain->active_page->current_lines) {
			gtk_clist_get_text(GTK_CLIST(widget),
				last_select_row,6,&text);
			if (last_select_row == 1)
			{
				gchar *temp2 = NULL;
				gtk_clist_unselect_row(GTK_CLIST(widget), last_select_row, 0);
				gtk_clist_unselect_row(GTK_CLIST(widget), last_select_row+1, 0);
				if (gnochivemain->active_page->ad->depth>0)
					gnochivemain->active_page->ad->depth--;
				temp2 = g_strdup( get_parent_directory(g_strconcat(G_DIR_SEPARATOR_S,
									gnochivemain->active_page->ad->root, NULL)));
				g_free(gnochivemain->active_page->ad->root);
				gnochivemain->active_page->ad->root = g_strdup(temp2+1); // get rid of the fake G_DIR_SEPARATOR
				//if (!cmpare(gnochivemain->active_page->ad->root, G_DIR_SEPARATOR_S))
				//{
					//g_free(gnochivemain->active_page->ad->root);
					//gnochivemain->active_page->ad->root = NULL;
				//}
				g_free(temp2);
				temp = g_strconcat(gnochivemain->active_page->ad->root, "/", NULL);
				if (gnochivemain->active_page->ad->depth>0)
					archive_cd(gnochivemain->active_page->clist, temp);
				last_select_row = 2;
				return TRUE;
			}
			else 
				if (text[0] == 'd') {
					gtk_clist_get_text(GTK_CLIST(widget), last_select_row, 1, &text);
					gtk_clist_unselect_row(GTK_CLIST(widget), last_select_row, 0);
					temp = g_strconcat(gnochivemain->active_page->ad->root, text, NULL);
					gnochivemain->active_page->ad->depth++;
					archive_cd(widget, temp);
					g_free(temp);
					return TRUE;
				}
				else {
					gtk_clist_get_text(GTK_CLIST(widget), last_select_row, 1, &text);
					rtxt = g_strconcat(gnochivemain->active_page->ad->root, text, NULL);
					tmpfile = extract_file_from_archive(gnochivemain->active_page->ad->full_name, rtxt);
					g_free(rtxt);
					gc_type = gnochive_get_archive_type(tmpfile);
					if (!gc_type) 
					{	
						if (!gnochivemain->gc_cfg->internal)
							gnochive_file_open_mime(tmpfile);
						else
							gnochive_file_open_internal(tmpfile);
					}
					else {
						open_real_archive(tmpfile);
						g_free(gc_type);
					}
					/*FIXME the child of an arhive should be removed when archive is closed*/
					//remove(tmpfile);
					g_free(tmpfile);
					return TRUE;
				}
		}
}
else 
{
	if (event->type == GDK_BUTTON_PRESS) {
		if (event->button == 2 || event->button == 3) {
			if (gnochivemain->active_page->opd_archive) {
				GdkEventButton *bevent = (GdkEventButton *) event;
				pager *ap = gnochivemain->active_page;
				gdk_window_get_pointer(NULL, &x, &y, NULL);
				if (!cmpare(ap->ad->type, "RAR") ||
					!cmpare(ap->ad->type, "zip") ||
					!cmpare(ap->ad->type, "zoo"))
				{
					if (attr[0] != 'd')
						menu_set_state(A_FILES_MENU + 0x100);
					else
						menu_set_state(A_FILES_MENU + 0x300);
				}
				else
				{
					if (attr[0] != 'd')
						menu_set_state(A_FILES_MENU);
					else
						menu_set_state(A_FILES_MENU + 0x100);
				}
				gtk_menu_popup(GTK_MENU(gnochivemain->mainmenu), NULL, NULL,
								NULL, NULL, bevent->button, bevent->time);
			}
			else {
				if (gnochivemain->active_page->files_selected == 1) {
					GdkEventButton *bevent = (GdkEventButton *) event;
					gchar *gc_type = NULL, *vfs_type = NULL;
					gdk_window_get_pointer(NULL, &x, &y, NULL);
					gc_type = gnochive_get_archive_type(text);
					vfs_type = gnochive_vfs_get_archive_type(text);
					if (!gc_type && !vfs_type)
					{
						if (attr[0] == 'd')
							menu_set_state(MULTI_MENU);
						else
							menu_set_state(SINGLE_MENU);
					}
					else
					{
						if (!cmpare(vfs_type, "tar"))
							menu_set_state(PLAIN_TAR_MENU);
						else
							menu_set_state(DECOMP_MENU);
						g_free(gc_type);
						g_free(vfs_type);
					}
					gtk_menu_popup(GTK_MENU(gnochivemain->mainmenu), NULL, NULL,
						NULL, NULL, bevent->button, bevent->time);
					
				}
				else
				{
					GdkEventButton *bevent = (GdkEventButton *) event;
					//if ((gnochivemain->active_page->files_selected > 1) || (cmpare(attr,"d") == 0))
					//{
						menu_set_state(MULTI_MENU);
						gtk_menu_popup(GTK_MENU(gnochivemain->mainmenu), NULL, NULL, 
										NULL,NULL,bevent->button,bevent->time);
					//}
					//else {
						//menu_set_state(SINGLE_MENU);
						//gtk_menu_popup(GTK_MENU(gnochivemain->mainmenu), NULL, NULL,
							//			NULL, NULL, bevent->button, bevent->time);
					//}
				}
			}
		}
	}
}
return TRUE;
}


#define ALT_L	0xFFE9
#define ALT_R	0xFFEA

gboolean
gnochive_key_press_event           (GtkWidget       *widget,
											GdkEventKey  *event,
											gpointer         user_data)
{
	gint page_num = 0;
	if (event->type == GDK_KEY_PRESS)
	{
		if (event->keyval == ALT_L || event->keyval == ALT_R)
			ALT_DOWN = TRUE;
		if ((ALT_DOWN) && (event->keyval >= 0x030 && event->keyval <= 0x039))
		{
			page_num = (event->keyval)-0x030-1;
			gnochive_jump_to_page(page_num);
			gtk_notebook_set_page(GTK_NOTEBOOK(gnochivemain->noter), page_num);
		}
	}
	return TRUE;
}

gboolean
gnochive_key_release_event           (GtkWidget       *widget,
											GdkEventKey  *event,
											gpointer         user_data)
{
	if (event->type == GDK_KEY_RELEASE)
		if (event->keyval == ALT_L || event->keyval == ALT_R)
			ALT_DOWN = FALSE;
	return TRUE;
}


void
on_combo_entry4_activate               (GtkEditable     *editable,
                                        gpointer         user_data)
{
	gchar *text = "\0";
	gchar *cur_dir = NULL;
	pager *ap;
	
	ap = gnochivemain->active_page;
	text = gtk_entry_get_text(GTK_ENTRY(editable));
	f_type(text);
	if (ap->opd_archive)
		gnochive_close_archive(ap->ad);
	chdir(text);
	gtk_clist_clear(GTK_CLIST(ap->clist));
	cur_dir = g_get_current_dir();
	gnochive_read_pwd_files(cur_dir);
	g_free(ap->path);
	ap->path = g_strdup(cur_dir);
	g_free(cur_dir);
	g_free(ap->selected_rows);
	ap->selected_rows = g_malloc(ap->current_lines);
	memset(ap->selected_rows, 0, ap->current_lines);
}

void
on_clist1_add                          (GtkContainer    *container,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{
g_print("dragged mumu to me");
}

void
on_clist1_drag_data_get                (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data)
{
	GtkCList *clist;
	gpointer *mydata;
	//gchar *text;
	
	clist = user_data;
	mydata = gtk_clist_get_row_data(GTK_CLIST(clist),3);
	gtk_selection_data_set(data,
						data->target,
						8, "file:/tmp/9563", strlen("file:/tmp/9563"));
	//g_print("data_get:%s\n",mydata->url);
}

void
create_right_menus			(void)
{
GtkAccelGroup *accel_group,*accel1_group,*accel2_group;
int items1_size;
accel_group=gtk_accel_group_new();
accel1_group=gtk_accel_group_new();
accel2_group=gtk_accel_group_new();
mypopup1=gtk_item_factory_new(GTK_TYPE_MENU,"<main>",accel1_group);
items1_size=sizeof(mypopup1_items) / sizeof(mypopup1_items[0]);
gtk_item_factory_create_items(mypopup1,items1_size,mypopup1_items,NULL);
}

void
myfnc_sel (void)
{
select_all=1;

return;
}

void
myfnc_unsel (void)
{
select_all=0;
gtk_clist_unselect_all(GTK_CLIST(gnochivemain->active_page->clist));
}

void
on_button18_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gchar *tmp;
tmp=gnome_help_file_find_file("gnochive","index.html");
if (tmp) {
    gnome_help_goto(0,tmp);
    g_free(tmp);
}
}

void
on_combo_entry6_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
gchar *text="\0";
gchar *ftype='\0';
gchar tmp[0x200];
GtkWidget *frame12;
frame12=lookup_widget(GTK_WIDGET(dialog1),"frame12");
gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist), last_select_row, 1, &text);
gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist), last_select_row, 2, &ftype);
if (ftype==0) ftype="\0";
strcpy(tmp,"\0");
entry1=lookup_widget(GTK_WIDGET(editable),"entry1");
arc_type=gtk_entry_get_text((GtkEntry *)editable);
//g_print("tip:%s",arc_type);
if (strcmp(arc_type,"RAR")==0)
 {
  gtk_widget_set_sensitive(user_data,TRUE);
  gtk_label_set_text(GTK_LABEL(s_ext),_(".rar"));
 }
else gtk_widget_set_sensitive(user_data,FALSE);
if ((strcmp(arc_type,"gz")==0) && (strcmp(ftype,"dir")!=0) && nrows!=0) {
			for (i=0;i<current_lines;i++) {
				if (selected_rows[i]==1) {
							gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist),i,1,&text);
							strcat(tmp,text);strcat(tmp,".gz ");
							}
				}
			gtk_entry_set_text((GtkEntry *)entry1,tmp);
			gtk_label_set_text(GTK_LABEL(s_ext),"");
			}
else gtk_entry_set_text((GtkEntry *)entry1,"\0");
if (strcmp(arc_type,"tar")==0)
 {
    gtk_widget_set_sensitive(frame12,TRUE);
    gtk_label_set_text(GTK_LABEL(s_ext),_(".tar"));
    sel_filter=0;		//jump to plain tar by default
 }
else gtk_widget_set_sensitive(frame12,FALSE);
if (strcmp(arc_type,"bzip2")==0) gtk_label_set_text(GTK_LABEL(s_ext),_(""));
if (strcmp(arc_type,"zip")==0) gtk_label_set_text(GTK_LABEL(s_ext),_(".zip"));
if (strcmp(arc_type,"lha")==0) gtk_label_set_text(GTK_LABEL(s_ext),_(".lha"));
if (strcmp(arc_type,"zoo")==0) gtk_label_set_text(GTK_LABEL(s_ext),_(".zoo"));
}


void
on_button45_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(dialog1);
compress_estimate=create_compress_estimate();
gtk_widget_show(compress_estimate);
}

void
on_compress_estimate_show                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
gchar *text="\0";
FILE *tmpf;
gchar name[100],size[10];
char buff[0x50];
GtkWidget *entry,*entry1,*entry2;
totalsize=0;totalpck=0;totalratio=0;
entry=lookup_widget(GTK_WIDGET(widget),"entry17");
entry1=lookup_widget(GTK_WIDGET(widget),"entry18");
entry2=lookup_widget(GTK_WIDGET(widget),"entry19");
tmpf=fopen("/tmp/gcparse","w+");
for (i=0;i<current_lines;i++) {
		if (selected_rows[i]==1) {
					memset(name,0,strlen(name));
					memset(size,0,strlen(size));
					gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist),i,1,&text);
					fprintf(tmpf,"%s\n",text);
					strcpy(name,text);
					(gchar *)clist1_line[0][0]=name;
					gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist),i,3,&text);
					strcpy(size,text);
					totalsize=totalsize+atoi(size);
					(gchar *)clist1_line[0][1]=size;
					if (strcmp(estm_type,"gz")==0) gzip_stat(name);
					gtk_clist_append((GtkCList *)user_data,clist1_line[0]);
					}
		}
fclose(tmpf);
rar_stat(user_data);
g_snprintf(buff,50,"%d",totalsize);
gtk_entry_set_text((GtkEntry *)entry,buff);
g_snprintf(buff,50,"%d",totalpck);
gtk_entry_set_text((GtkEntry *)entry1,buff);
totalratio=(totalpck*100)/totalsize;
g_snprintf(buff,50,"%.1f",totalratio);
gtk_entry_set_text((GtkEntry *)entry2,buff);
}


void
on_checkbutton20_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
int togg=gtk_toggle_button_get_active(togglebutton) ? TRUE : FALSE;
if (togg!=gnochivemain->gc_cfg->res_syms) gnome_property_box_changed((GnomePropertyBox *)gnochivemain->gc_cfg->widget);
if (togg) {
	    gnochivemain->gc_cfg->res_syms=1;
	    if (gnochivemain->active_page->opd_archive) {
			refresh_dir(".");
			last_select_row=0;
		    gnochivemain->active_page->files_selected=0;
		    total_sel_size=0;
		}
}
else {
    gnochivemain->gc_cfg->res_syms=0;
    if (gnochivemain->active_page->opd_archive) {
	    refresh_dir(".");
		last_select_row=0;
	    gnochivemain->active_page->files_selected=0;
    	total_sel_size=0;
	}
    }
}


void
on_checkbutton25_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
int togg=gtk_toggle_button_get_active(togglebutton) ? TRUE : FALSE;
#ifdef USE_GNOME
if (togg!=gnochivemain->gc_cfg->popn) gnome_property_box_changed((GnomePropertyBox *)gnochivemain->gc_cfg->widget);
#endif
if (togg) gnochivemain->gc_cfg->popn=1;
else gnochivemain->gc_cfg->popn=0;
}

void
on_radiobutton11_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
if (sel_mode == 0)
	{
		gtk_clist_set_selection_mode(GTK_CLIST(gnochivemain->active_page->clist),GTK_SELECTION_MULTIPLE);
		sel_mode = 1;
	}
}


void
on_radiobutton10_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
if (sel_mode == 1)
	{
		gtk_clist_set_selection_mode(GTK_CLIST(gnochivemain->active_page->clist), GTK_SELECTION_EXTENDED);
		sel_mode=0;
	}
}


void
on_button57_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}



void
on_button60_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(dialog5);
}


void
on_button61_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(dialog5);
}


void
on_button62_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(dialog5);
}


void
on_radiobutton16_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
sel_filter=0;
gtk_label_set_text(GTK_LABEL(s_ext),_(".tar"));
}


void
on_radiobutton17_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
sel_filter=1;
gtk_label_set_text(GTK_LABEL(s_ext),_(".tar.gz"));
}


void
on_radiobutton18_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
sel_filter=2;
gtk_label_set_text(GTK_LABEL(s_ext),_(".tar.bz2"));
}

void
on_button75_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button76_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(user_data);
}


void
on_button77_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
dialog11=create_dialog11();
gtk_widget_show(dialog11);
}


void
on_button79_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(dialog11);
}


void
on_button7_show                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
button7=widget;
}


void
on_button81_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(compress_estimate);
}

gboolean
init_gnome_progress(void)
{
	progr=0;
	//gnome_app_progress_timeout(mainwindow,"open",100,mytime,NULL,0);
	return 0;
}

void
on_combo_entry12_changed               (GtkEditable     *editable,
                                        gpointer         user_data)
{
gchar *arc_type;
gchar *text="\0";
gchar name[100],size[10];
char buff[0x50];
GtkWidget *entry,*entry1,*entry2,*label,*label1,*label2;
totalsize=0;totalpck=0;totalratio=0;
arc_type=gtk_entry_get_text((GtkEntry *)editable);
entry=lookup_widget(GTK_WIDGET(compress_estimate),"entry17");
entry1=lookup_widget(GTK_WIDGET(compress_estimate),"entry18");
entry2=lookup_widget(GTK_WIDGET(compress_estimate),"entry19");
label=lookup_widget(GTK_WIDGET(compress_estimate),"label150");
label1=lookup_widget(GTK_WIDGET(compress_estimate),"label152");
label2=lookup_widget(GTK_WIDGET(compress_estimate),"label153");
clist2=lookup_widget(GTK_WIDGET(compress_estimate),"clist2");
if (strcmp(arc_type,"gzip")==0) {
    totalsize=0;totalpck=0;totalratio=0;
    gtk_clist_freeze(GTK_CLIST(clist2));
    gtk_clist_clear(GTK_CLIST(clist2));
    for (i=0;i<current_lines;i++) {
		if (selected_rows[i]==1) {
					memset(name,0,strlen(name));
					memset(size,0,strlen(size));
					gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist), i, 1, &text);
					strcpy(name,text);
					(gchar *)clist1_line[0][0]=name;
					gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist),i,3,&text);
					strcpy(size,text);
					totalsize=totalsize+atoi(size);
					(gchar *)clist1_line[0][1]=size;
					gzip_stat(name);
					gtk_clist_append(GTK_CLIST(clist2),clist1_line[0]);
					}
		}
gtk_clist_thaw(GTK_CLIST(clist2));		
gtk_widget_set_sensitive(label,TRUE);
gtk_widget_set_sensitive(label1,TRUE);
gtk_widget_set_sensitive(label2,TRUE);
}
if (strcmp(arc_type,"RAR")==0) rar_stat(0);
if (strcmp(arc_type,"bzip2")==0) {
		totalsize=0;totalpck=0;totalratio=0;
		gtk_clist_freeze(GTK_CLIST(clist2));
		gtk_clist_clear(GTK_CLIST(clist2));
		for (i=0;i<current_lines;i++) {
		if (selected_rows[i]==1) {
					memset(name,0,strlen(name));
					memset(size,0,strlen(size));
					gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist),i,1,&text);
					strcpy(name,text);
					(gchar *)clist1_line[0][0]=name;
					(gchar *)clist1_line[0][1]=size;
					memset(clist1_line,0,sizeof(clist1_line));
					bzip_stat((gpointer)clist2);
					}
		}
		gtk_clist_thaw(GTK_CLIST(clist2));
		gtk_widget_set_sensitive(label,TRUE);
		gtk_widget_set_sensitive(label1,TRUE);
		gtk_widget_set_sensitive(label2,TRUE);
		}
if (strcmp(arc_type,"zip")==0) {
				gtk_clist_clear(GTK_CLIST(clist2));
				totalsize=1;
				totalpck=1;
				totalratio=0;
				}
gtk_clist_thaw(GTK_CLIST(clist2));
g_snprintf(buff,50,"%d",totalsize);
gtk_entry_set_text((GtkEntry *)entry,buff);
g_snprintf(buff,50,"%d",totalpck);
gtk_entry_set_text((GtkEntry *)entry1,buff);
totalratio=(totalpck*100)/totalsize;
g_snprintf(buff,50,"%.1f",totalratio);
gtk_entry_set_text((GtkEntry *)entry2,buff);
}


void
on_dialog1_show                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
//progressbar2=lookup_widget(GTK_WIDGET(widget),"progressbar2");
(gchar *)arc_type=0;
strcpy(comp_command,"-5");		/* normal compression by default (maybe best) ?*/
s_ext=lookup_widget(GTK_WIDGET(widget),"label221");
gtk_label_set_text(GTK_LABEL(s_ext),_(".rar"));
}

void
on_button83_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
if (!gnochivemain->active_page->opd_archive)
	refresh_dir(".");
else
	refresh_arch(gnochivemain->active_page->ad);
	last_select_row=0;
    gnochivemain->active_page->files_selected=0;
    total_sel_size=0;
}


void
on_button84_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
//dialog5=create_dialog5();
//gtk_widget_show(dialog5);
}


void
on_build_installer1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

void
on_close_this_window1_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if (gnochivemain->active_page->opd_archive)
	{
		gnochive_close_archive(gnochivemain->active_page->ad);
		last_select_row=0;
		gnochivemain->active_page->files_selected = 0;
	}
}

void
on_close_all_activate         (GtkMenuItem     *menuitem,
                               gpointer         user_data)
{
	pager *first = NULL;
	first = (pager *) gnochivemain->gc_pager->next;
	while (first)
	{
		gnochive_jump_to_page(first->page_no);
		gnochive_close_archive(first->ad);
		first = (pager *) gnochivemain->gc_pager->next;
	}
}

void
on_combo_entry4_drag_data_received     (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data)
{
gchar *text = NULL;
text=gtk_entry_get_text((GtkEntry *)widget);
gnochive_close_archive(gnochivemain->active_page->ad);
chdir(text);
gtk_clist_clear(GTK_CLIST(gnochivemain->active_page->clist));
gnochive_read_pwd_files(".");
free(selected_rows);
selected_rows=malloc(current_lines);
memset(selected_rows,0,current_lines);
}


gboolean
on_combo_entry14_key_press_event       (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_button90_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(user_data);
}



void
on_button23_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_log1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_widget_show(gnochivemain->log_window);
}


void
on_estimate_repack1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

void
on_propertybox3_apply                  (GnomePropertyBox *gnomepropertybox,
                                        gint             arg1,
                                        gpointer         user_data)
{
save_changes();
//update_all(GTK_WIDGET(gnomepropertybox));
}

void
on_propertybox3_help                   (GnomePropertyBox *gnomepropertybox,
                                        gint             arg1,
                                        gpointer         user_data)
{
g_print("man:%d",arg1);
}


void
on_propertybox3_show                   (GtkWidget       *widget,
                                        gpointer         user_data)
{
	GtkWidget *menu = lookup_widget(GTK_WIDGET(widget),"appear_menu");
	GtkWidget *mymenu = create_appearance_menu();
	GtkWidget *menu2 = lookup_widget(GTK_WIDGET(widget),"tabs_menu");
	GtkWidget *mymenu2 = create_tabs_menu();
	
	gtk_option_menu_set_menu(GTK_OPTION_MENU(menu),mymenu);
	gtk_option_menu_set_history(GTK_OPTION_MENU(menu),gnochivemain->gc_cfg->tstyle);
	gtk_option_menu_set_menu(GTK_OPTION_MENU(menu2),mymenu2);
	gtk_option_menu_set_history(GTK_OPTION_MENU(menu2),gnochivemain->gc_cfg->tbstyle);
	display_comments(widget);
}

void
on_checkbutton58_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
int togg = gtk_toggle_button_get_active(togglebutton) ? TRUE : FALSE;
if (togg!=gnochivemain->gc_cfg->bz2flag)
	gnome_property_box_changed((GnomePropertyBox *)gnochivemain->gc_cfg->widget);
gnochivemain->gc_cfg->bz2flag=togg;
}

void
prepare_arc_menu			(void)
{
//arc_items=g_list_append(arc_items,"<Current dir>");
//gtk_combo_set_popdown_strings(GTK_COMBO(arcmenu1),arc_items);
}

gboolean
on_combo_entry4_key_press_event        (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
gtk_widget_grab_focus(widget);
  return FALSE;
}


gboolean
on_clist1_key_release_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
gchar *text='\0';
gtk_clist_get_text(GTK_CLIST(widget),last_select_row,1,&text);
if (event->keyval==0xff0d)
 {
    if (gnochivemain->active_page->opd_archive!=0) {
			if (last_select_row!=0 && last_select_row!=1) {
			    gtk_clist_get_text(GTK_CLIST(widget),last_select_row,6,&text);
			    if (cmpare(text,"d")==0) {
					gtk_clist_get_text(GTK_CLIST(widget),last_select_row,1,&text);
					gtk_clist_unselect_row(GTK_CLIST(widget),last_select_row,0);
					chdir(text);
					gtk_clist_clear(GTK_CLIST(widget));
					read_pwd_files(".");
					last_select_row=0;
					gnochivemain->active_page->files_selected=0;
					total_sel_size=0;
					free(selected_rows);
					selected_rows=malloc(current_lines);
					memset(selected_rows,0,current_lines);
					gnome_appbar_clear_stack(GNOME_APPBAR(gnochivemain->mainbar));
					return TRUE;
			    }
			    gtk_clist_get_text(GTK_CLIST(widget),last_select_row,1,&text);
			    //strcpy(opd_archive_name,text);
				//open_archive(text,0);
			    return TRUE;
			    }
			    if ((last_select_row==0) || (last_select_row==1)) {
				// *FIXME* //
							    gtk_clist_unselect_row(GTK_CLIST(gnochivemain->active_page->clist),last_select_row,0);
							    chdir(text);
							    gtk_clist_clear(GTK_CLIST(widget));
							    read_pwd_files(".");
							    last_select_row=0;
							    gnochivemain->active_page->files_selected=0;
							    total_sel_size=0;
							    free(selected_rows);
							    selected_rows=malloc(current_lines);
							    memset(selected_rows,0,current_lines);
							    gnome_appbar_clear_stack(GNOME_APPBAR(gnochivemain->mainbar));
							    return TRUE;
							}
				}
}
  return TRUE;
}

void
on_radiobutton26_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
sel_filter=3;
gtk_label_set_text(GTK_LABEL(s_ext),_(".tar.Z"));
}


void
on_radiobutton27_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
sel_filter=4;
strcpy(custom_filter,gtk_entry_get_text(GTK_ENTRY(user_data)));
}


void
on_entry44_changed                     (GtkEditable     *editable,
                                        gpointer         user_data)
{
strcpy(custom_filter,gtk_entry_get_text(GTK_ENTRY(user_data)));
}



void
on_button107_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *my;
	gboolean res = FALSE;
	gboolean tpath;
	gchar *temp = NULL;
	gchar *newname = NULL;
	gchar *text = gtk_entry_get_text(GTK_ENTRY(user_data));
	if (strlen(text)) {
		my_ad = (archivedesc *)g_malloc(sizeof(archivedesc));
		
		if (my_ad)
		{
			my_ad->type = g_strdup(gnochivemain->qdialog->arc_type);
			my_ad->sub_type = gnochivemain->qdialog->filter;
			my_ad->compress_level = g_strdup(gnochivemain->qdialog->comp_command);
			my_ad->locked = FALSE;
			my_ad->dict_size = g_strdup("-md256");
			my_ad->volume = 0;
			
			my = lookup_widget(GTK_WIDGET(button), "combo_entry23");
			temp = g_strdup(gtk_entry_get_text(GTK_ENTRY(my)));
			/*obtain the full path for the new archive which is about to be created*/
			if (strlen(temp)) {
				my_ad->name = g_concat_dir_and_file(temp,
						gtk_entry_get_text(GTK_ENTRY(user_data)));
				tpath=1;
			} 
			else {
				my_ad->name = g_strdup(gtk_entry_get_text(GTK_ENTRY(user_data)));
				tpath=0;
			}
			res = create_archive(my_ad);
			destroy_quick_dialog();
			if (res) {
				gnome_app_flash(GNOME_APP(gnochivemain->mainwin),
						_("Sucessfully created archive."));
				if (gnochivemain->gc_cfg->popn)
				{
					newname=g_strdup(my_ad->full_name);
					my_ad=open_real_archive(newname);
					g_free(newname);
				}
				else refresh_dir(".");
			}
			g_free(temp);
		}
	}
}


void
on_button108_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	destroy_quick_dialog();
}

/*destructs the quick pack dialog + all data g_malloc'd to it*/

void
destroy_quick_dialog(void)
{
	g_free(gnochivemain->qdialog->q_ext);
	//g_free(gnochivemain->qdialog->q_name);
	g_free(gnochivemain->qdialog->comp_command);
	g_free(gnochivemain->qdialog->arc_type);
	//g_free(gnochivemain->qdialog->full_name);
	//g_free(gnochivemain->qdialog->name);
	//g_free(gnochivemain->qdialog->path);
	gtk_widget_destroy(gnochivemain->qdialog->dialog);
	g_free(gnochivemain->qdialog);
}

void
on_dialog13_show                       (GtkWidget       *widget,
                                        gpointer         user_data)
{
	GtkWidget *qentry;
	GtkWidget *lext;
	GtkWidget *combo;
	struct passwd *pw;
	gchar *path, *qname = NULL;
	gchar *text, *attr;
	
	qname = g_strdup("\0");
	qentry = lookup_widget(GTK_WIDGET(widget), "entry46");
	lext = lookup_widget(GTK_WIDGET(widget), "label224");
	combo = lookup_widget(GTK_WIDGET(widget), "combo_entry23");
	
	if (gnochivemain->active_page->files_selected == 1)
	{
		gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist),
			last_select_row, 1, &text);
		gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist),
			last_select_row, 6, &attr);
		if (attr[0] == 'd')
		{
			g_free(qname);
			qname = g_strdup(text);
		}
	}
	
	pw = getpwuid(getuid());
	path = g_strdup(pw->pw_dir);
	
	gtk_label_set_text(GTK_LABEL(lext), gnochivemain->qdialog->q_ext);
	gtk_entry_set_text(GTK_ENTRY(qentry), qname);
	gtk_entry_select_region(GTK_ENTRY(qentry), 0, -1);
	gtk_entry_set_text(GTK_ENTRY(combo), path);
	g_free(qname);
	g_free(path);
}


void
on_combo_entry17_changed               (GtkEditable     *editable,
                                        gpointer         user_data)
{
	/* we xlat the compression commands since not all archivers use the same parameters */
	gchar *generic_comp[]={"-1","-5","-9","-1","-5","-9","o","o5","o6","f","","h"};
	guint myid=0;
		
	if (!cmpare(gnochivemain->qdialog->arc_type,"tar"))
		myid=0;
	if (!cmpare(gnochivemain->qdialog->arc_type,"RAR"))
		myid=3;
	if (!cmpare(gnochivemain->qdialog->arc_type,"lha"))
		myid=6;
	if (!cmpare(gnochivemain->qdialog->arc_type,"zoo"))
		myid=9;
	compression_level=gtk_entry_get_text(GTK_ENTRY(editable));
 	if (strcmp(compression_level,"Store")==0)
		gnochivemain->qdialog->comp_command=g_strdup(generic_comp[myid]);
 	if (strcmp(compression_level,"Normal")==0)
		gnochivemain->qdialog->comp_command=g_strdup(generic_comp[myid+1]);
 	if (strcmp(compression_level,"Best")==0)
		gnochivemain->qdialog->comp_command=g_strdup(generic_comp[myid+2]);
}


void
on_checkbutton67_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
if (!wdstate) wdstate=TRUE;
else wdstate=FALSE;
gtk_widget_set_sensitive(GTK_WIDGET(wdentry),(gboolean)wdstate);
gtk_widget_set_sensitive(GTK_WIDGET(nbutton),(gboolean)wdstate);
}

void
on_button83_enter                      (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button83_leave                      (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button77_enter                      (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button77_leave                      (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_cclist_toggled                      (GtkToggleButton *togglebutton,
                                        gboolean         user_data)
{
int st = gtk_toggle_button_get_active(togglebutton) ? TRUE : FALSE;
if (st)
	gtk_clist_set_column_visibility(GTK_CLIST(gnochivemain->active_page->clist),
									user_data, st);
else
	gtk_clist_set_column_visibility(GTK_CLIST(gnochivemain->active_page->clist),
									user_data, st);
if (gnochivemain->gc_cfg->complete)
	gnome_property_box_changed(GNOME_PROPERTY_BOX(gnochivemain->gc_cfg->widget));
}

void
on_path_clicked                        (GtkButton       *button,
                                        gint         user_data)
{
	gchar mytitle[0x50];
	gchar *arcs[] = {"RAR","gzip","tar","zip","bzip2","compress","unARJ","unACE","LHA","Zoo"};
		
g_snprintf(mytitle,0x50,_("Select %s path"),arcs[user_data]);
pathwin = gtk_file_selection_new(mytitle);
gtk_window_set_modal(GTK_WINDOW(pathwin),TRUE);
gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(pathwin)->ok_button),
		    "clicked",GTK_SIGNAL_FUNC(parse_pentry),(gint *)user_data);
gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(pathwin)->ok_button),
		    "clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),
		    (gpointer) pathwin);
gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(pathwin)->cancel_button),
		    "clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),
		    (gpointer) pathwin);
gtk_widget_show(pathwin);
}

void
parse_pentry				(GtkFileSelection *win,gint user_data)
{
	GtkWidget *tmpwid;
	gchar *lbls[] = {"entry32", "entry33", "entry35", "entry34", "entry36",
					"entry45", "entry48", "entry49", "entry50", "entry51"};
					
	tmpwid = lookup_widget(GTK_WIDGET(gnochivemain->gc_cfg->widget), lbls[user_data]);
	gtk_entry_set_text(GTK_ENTRY(tmpwid),
    gtk_file_selection_get_filename(GTK_FILE_SELECTION(pathwin)));
}

void
on_pentry_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
if (gnochivemain->gc_cfg->complete)
	gnome_property_box_changed(GNOME_PROPERTY_BOX(gnochivemain->gc_cfg->widget));
}

void
on_checkbutton94_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
if (gtk_toggle_button_get_active(togglebutton) ? TRUE : FALSE)
    {
		gtk_clist_column_titles_show(GTK_CLIST(gnochivemain->active_page->clist));
		gnochivemain->gc_cfg->tit=1;
	}
else {
	gtk_clist_column_titles_hide(GTK_CLIST(gnochivemain->active_page->clist));
	gnochivemain->gc_cfg->tit=0;
	}
if (gnochivemain->gc_cfg->complete) gnome_property_box_changed((GnomePropertyBox *)gnochivemain->gc_cfg->widget);
}

void
on_clist1_drag_begin                   (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gpointer         user_data)
{
	//FILE *tmpf;
	gchar *text = NULL;
	guint i;
	
	g_print("draggin base row:%d\n",last_select_row);
	
	//tmpf = fopen("/tmp/gcparse", "w");
	for (i=0;i<gnochivemain->active_page->current_lines;i++)
	{
		if (gnochivemain->active_page->selected_rows[i] == 1) {
			gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist), i, 1, &text);
			//gtk_clist_unselect_row(GTK_CLIST(gnochivemain->active_page->clist), i, 0);
			//gtk_clist_unselect_row(GTK_CLIST(clist1),i,0);
			//fprintf(tmpf,"%s\n",text);
			g_print("file:%d-%s\n", i,text);
		}
	}
//fclose(tmpf);
}


void
on_clist1_drag_end                     (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gpointer         user_data)
{
g_print("end");
}


void
on_combo_entry18_activate              (GtkEditable     *editable,
                                        gpointer         user_data)
{
	gchar *text = NULL;
	gchar *temp = NULL;
	
	text = gtk_entry_get_text(GTK_ENTRY(editable));
	if (text[strlen(text) - 1] != G_DIR_SEPARATOR)
		temp = g_strconcat(text, G_DIR_SEPARATOR_S, NULL);
	else
		temp = g_strdup(text);
	g_print("%s\n",text);
	gnochivemain->active_page->ad->depth++;
	archive_cd(gnochivemain->active_page->clist, temp);
	g_free(temp);
}

void
on_targz1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
convert_arch("tgz");
}


void
on_tarbz1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
convert_arch("tbz2");
}


void
on_tarz1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
convert_arch("comp");
}

GtkWidget*
my_anim (gchar *widget_name, gchar *imgname, gchar *string2,
                gint size, gint freq)
{
	GtkWidget *w;
	gchar *pixmap=NULL;

	w = gnome_animator_new_with_size (48, 48);

	gnome_animator_set_loop_type (GNOME_ANIMATOR (w),
				      GNOME_ANIMATOR_LOOP_RESTART);
	//pixmap = g_strconcat ("src", imgname, NULL);
	gnome_animator_append_frames_from_file (GNOME_ANIMATOR (w),
						imgname, 0, 0, freq, size);
	g_free (pixmap);
	return w;
}

void
gnochive_open_file_from_toolbar(void)
{
	/*gchar *myname;
	curprogress=0.15;
	opd_archive=0;
	opd_archive_name=gtk_file_selection_get_filename (GTK_FILE_SELECTION(user_data));
	memcpy((gchar*)name,opd_archive_name,0x100);
	gnome_appbar_set_progress(GNOME_APPBAR(gnochivemain->mainwin),curprogress);
	rarfile=0;
	rarfile=fopen(opd_archive_name,"r");
	close_arch(0);
	fread(fbuffer,4,1,rarfile);		//4
	fclose(rarfile);
	myname=extract_filename(opd_archive_name);
	arc_items=g_list_append(arc_items,myname);
	gtk_combo_set_popdown_strings(GTK_COMBO(arcmenu1),arc_items);
	g_free(myname);
	arc_type='\0';
	if (rarfile!=0) {
				if(strncmp(fbuffer,RAR_MAGIC,4)==0) rar_open(opd_archive_name);
				if(strncmp(fbuffer,GZIP_MAGIC,2)==0) gzip_open(opd_archive_name);
				if(strncmp(fbuffer,ZIP_MAGIC,2)==0) zip_open(opd_archive_name);
				if(strncmp(fbuffer,Z_MAGIC,2)==0) Z_open(opd_archive_name);
				if(strncmp(fbuffer,ARJ_MAGIC,2)==0) arj_open(opd_archive_name);*/
				/* if we do not have a magic we'll fall back to plain tar */
				/*FIXME! tar open needs a magic */
				//tar_open(opd_archive_name);
		//corrupt_arch();
	//}
}


void
on_button8_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	g_print("here");
	//create_myfile_selection();
}

void
on_appearance_changed               (GtkEditable     *editable,
                                        gpointer         user_data)
{
	gchar *res;
	GtkRadioButton *radio1;
	guint gbutton;
	gnome_property_box_changed((GnomePropertyBox *)gnochivemain->gc_cfg->widget);
	res=g_strdup(gtk_entry_get_text(GTK_ENTRY(editable)));
	radio1=(GtkRadioButton *)lookup_widget(GTK_WIDGET(gnochivemain->gc_cfg->widget),"radiobutton28");
	gbutton=gtk_radio_button_get(radio1);
	
	if (!cmpare(res,"Text beside icons"))
		gnochivemain->gc_cfg->tstyle=1;
	if (!cmpare(res,"Text under icons"))
		gnochivemain->gc_cfg->tstyle=1;
	if (!cmpare(res,"Text only"))
		gnochivemain->gc_cfg->tstyle=3;
	if (!cmpare(res,"Icons only"))
		gnochivemain->gc_cfg->tstyle=2;
	g_free(res);
}

gint
gtk_radio_button_get (GtkRadioButton *radio_button)
{
	GtkToggleButton *toggle_button;
	gint i, length;
        GSList *list;
	
	/* get group list */
        list = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_button));
        length = g_slist_length (list);

	/* iterate over list to find active button */
	for (i = 0; list != NULL; i++, list = g_slist_next (list))
	{
		/* get button and text */
		toggle_button = GTK_TOGGLE_BUTTON (list->data);
		if (gtk_toggle_button_get_active (toggle_button))
		{
			break;
		}
	}

	/* check we didn't run off end */
	g_assert (list != NULL);

	/* return index (reverse order!) */
	return (length - 1) - i;
}

void
gtk_radio_button_set (GtkRadioButton *radio_button, gint index)
{
	GtkToggleButton *button;
	GSList *list;
	gint length;

	/* get the list */
        list = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_button));

	/* check out the length */
        length = g_slist_length (list);

        /* new buttons are *preppended* to the list, so button added as first 
         * has last position in the list */
        index = (length - 1) - index;

	/* find the right button */
        button = GTK_TOGGLE_BUTTON (g_slist_nth_data (list, index));

	/* set it... this will de-activate the others in the group */
	if (gtk_toggle_button_get_active (button) == FALSE)
	{
		gtk_toggle_button_set_active (button, TRUE);
	}
}


void
on_radiobutton28_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	gnome_property_box_changed((GnomePropertyBox *)gnochivemain->gc_cfg->widget);
	gnochivemain->gc_cfg->gbstat=0;
}


void
on_radiobutton29_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	gnome_property_box_changed((GnomePropertyBox *)gnochivemain->gc_cfg->widget);
	gnochivemain->gc_cfg->gbstat = 1;
}


void
on_radiobutton30_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	gnome_property_box_changed((GnomePropertyBox *)gnochivemain->gc_cfg->widget);
	gnochivemain->gc_cfg->gbstat=2;
}


gint
on_propertybox3_close                  (GnomeDialog     *gnomedialog,
                                        gpointer         user_data)
{
gtk_widget_hide(GTK_WIDGET(gnomedialog));
}


void
on_notebook_switch_page               (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        gint             page_num,
                                        gpointer         user_data)
{
	gnochive_jump_to_page(page_num);
}

void
gnochive_jump_to_page(gint page_num)
{
	pager *temp_pg;
	gchar *title = NULL;
	GtkWidget *subwd = lookup_widget(GTK_WIDGET(gnochivemain->mainwin),
									"combo_entry18");
	
	if (gnochivemain->active_page->bt && gnochivemain->active_page->bt_gr)
	{
		gtk_widget_hide(gnochivemain->active_page->bt);
		gtk_widget_show(gnochivemain->active_page->bt_gr);
	}
	
	temp_pg = gnochive_dig_pager(page_num);
	if (temp_pg != NULL)
	{
		gnochivemain->active_page = temp_pg;
		if (gnochivemain->active_page->opd_archive)
		{
			gtk_entry_set_text(GTK_ENTRY(entry6),
				gnochivemain->active_page->ad->full_name);
			gtk_widget_set_sensitive(GTK_WIDGET(entry6), FALSE);
			gtk_widget_set_sensitive(GTK_WIDGET(subwd), TRUE);
			gtk_entry_set_text(GTK_ENTRY(subwd),
				gnochivemain->active_page->ad->root);
			title = g_strdup_printf(N_("%s: %s"), GNOCHIVE_VER,
								gnochivemain->active_page->ad->full_name);
			gtk_widget_show(gnochivemain->active_page->bt);
			gtk_widget_hide(gnochivemain->active_page->bt_gr);
		}
		else {
			gtk_entry_set_text(GTK_ENTRY(entry6), gnochivemain->active_page->path);
			gtk_widget_set_sensitive(GTK_WIDGET(entry6), TRUE);
			gtk_widget_set_sensitive(GTK_WIDGET(subwd), FALSE);
			title=g_strdup_printf(N_("%s: %s"), GNOCHIVE_VER,
									gnochivemain->active_page->path);
			gtk_entry_set_text(GTK_ENTRY(subwd), "\0");
		}
		gtk_window_set_title(GTK_WINDOW(gnochivemain->mainwin), title);
		if (title) g_free(title);
		update_main_menu(menu);
	}
}


void
on_button196_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	gnochivemain->dirparent=user_data;
	gtk_widget_show(gnochivemain->dirsel);
}

void
on_button197_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	gnochivemain->dirparent=user_data;
	gtk_widget_show(gnochivemain->dirsel);
}

void
on_main_toolbar1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *dock;
	GnomeDockItem *item;
	item = gnome_app_get_dock_item_by_name(gnochivemain->app, "toolbar1");
	dock = lookup_widget(GTK_WIDGET(gnochivemain->mainwin), "dock1");
	if (gnochivemain->gc_cfg->main_visible)
	{
		gtk_widget_hide(GTK_WIDGET(item));
		gnochivemain->gc_cfg->main_visible = FALSE;
	}
	else
	{
		gtk_widget_show(GTK_WIDGET(item));
		gnochivemain->gc_cfg->main_visible = TRUE;
	}
	gtk_widget_queue_resize(GTK_WIDGET(dock));
}


void
on_extended_toolbar1_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *dock;
	GnomeDockItem *item;
	item = gnome_app_get_dock_item_by_name(gnochivemain->app, "toolbar2");
	dock = lookup_widget(GTK_WIDGET(gnochivemain->mainwin), "dock1");
	if (gnochivemain->gc_cfg->archive_visible)
	{
		gtk_widget_hide(GTK_WIDGET(item));
		gnochivemain->gc_cfg->archive_visible = FALSE;
	}
	else
	{
		gtk_widget_show(GTK_WIDGET(item));
		gnochivemain->gc_cfg->archive_visible = TRUE;
	}
	gtk_widget_queue_resize(GTK_WIDGET(dock));
}


void
on_location_toolbar1_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *dock;
	GnomeDockItem *item;
	item = gnome_app_get_dock_item_by_name(gnochivemain->app, "toolbar3");
	dock = lookup_widget(GTK_WIDGET(gnochivemain->mainwin), "dock1");
	if (gnochivemain->gc_cfg->location_visible)
	{
		gtk_widget_hide(GTK_WIDGET(item));
		gnochivemain->gc_cfg->location_visible = FALSE;
	}
	else
	{
		gtk_widget_show(GTK_WIDGET(item));
		gnochivemain->gc_cfg->location_visible = TRUE;
	}
	gtk_widget_queue_resize(GTK_WIDGET(dock));
}

void
on_item8_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_clist_select_all(GTK_CLIST(gnochivemain->active_page->clist));
	gtk_clist_unselect_row(GTK_CLIST(gnochivemain->active_page->clist),0,0);
	gtk_clist_unselect_row(GTK_CLIST(gnochivemain->active_page->clist),1,0);
}

void
on_un_select_all1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
gtk_clist_unselect_all(GTK_CLIST(gnochivemain->active_page->clist));
}


void
on_copy2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_properties2_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	
	if (gnochivemain->active_page->opd_archive)
	{
		if (!cmpare(gnochivemain->active_page->ad->type, "rpm"))
			rpm_dummy_info(gnochivemain->active_page->ad->full_name);
		else
			show_props(gnochivemain->active_page->ad);
	}
}

void
on_button201_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button198_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *combo = lookup_widget(GTK_WIDGET(button), "combo_entry24");
	GtkWidget *mbox;
	gchar *tfile;
	gchar *tfile2 = g_concat_dir_and_file(TMPDIR, "gchiveXXXXXX");
	gchar *path;
	gchar *temp = NULL, *text, *attr = NULL;
	gchar *file_name;
	gchar *pwd = g_get_current_dir();
	gchar *name = NULL;
	gboolean error;
	gchar *files = NULL;
	gchar *subent = NULL;
	FILE *tmpf;
	int tf, tf2;
	GtkWidget *subwd = lookup_widget(GTK_WIDGET(gnochivemain->mainwin), "combo_entry18");

	//if we're inside an archive get the file acording to root path
	if (gnochivemain->active_page->opd_archive)	
	{
		tf = mkstemp(tfile2);
		tmpf = fopen(tfile2,"w");
		subent = gtk_entry_get_text(GTK_ENTRY(subwd));
		if (!cmpare(gnochivemain->active_page->ad->type, "zip")
			|| (!cmpare(gnochivemain->active_page->ad->type, "zoo")))
		{
			fprintf(tmpf, "#!/bin/sh\n$1 $2 $3 ");
			for (i=0;i<gnochivemain->active_page->current_lines;i++)
			{
				if (gnochivemain->active_page->selected_rows[i] == 1)
				{
				gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist),i,1,&text);
				gtk_clist_unselect_row(GTK_CLIST(gnochivemain->active_page->clist),i,0);
				if (subent != NULL)
				{
					temp = g_concat_dir_and_file(subent,text);
					fprintf(tmpf,"%s ",temp);
					g_free(temp);
				}
				else
					fprintf(tmpf,"%s ",text);
				}
			}
			fprintf(tmpf, "$4 $5");
		}
		else
		{
			for (i=0;i<gnochivemain->active_page->current_lines;i++)
			{
				if (gnochivemain->active_page->selected_rows[i] == 1)
				{
				gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist),
						i, 1, &text);
				gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist),
						i, 6, &attr);
				gtk_clist_unselect_row(GTK_CLIST(gnochivemain->active_page->clist),
						i, 0);
				if (strlen(subent) != 0)
				{
					temp = g_concat_dir_and_file(subent,text);
					if (!cmpare(gnochivemain->active_page->ad->type, "cpio")
						|| !cmpare(gnochivemain->active_page->ad->type, "rpm"))
					{
						if (attr[0]=='d')
							fprintf(tmpf, "./%s?*\n", temp);
						else
						fprintf(tmpf, "./%s\n", temp);
					}
					else
						fprintf(tmpf, "%s\n", temp);
					g_free(temp);
				}
				else
				{
					if (!cmpare(gnochivemain->active_page->ad->type, "cpio")
						|| !cmpare(gnochivemain->active_page->ad->type, "rpm"))
					{
						if (attr[0]=='d')
							fprintf(tmpf, "./%s?*\n", text);
						else
						fprintf(tmpf, "./%s\n", text);
					}
					else
						fprintf(tmpf,"%s\n",text);
				}
				}
			}
		}
		fclose(tmpf);
		close(tf);	/*exec won't work as long as file is open , blame mkstemp for that,heh */
		files = tfile2;
		file_name = g_strdup(gnochivemain->active_page->ad->full_name);
	}
	else
	{
		gtk_clist_get_text(GTK_CLIST(gnochivemain->active_page->clist),
						last_select_row, 1, &text);
		name = g_strdup(text);
		file_name = g_strconcat(pwd, G_DIR_SEPARATOR_S, name, NULL);	/*we always need full path here */
		files = NULL;
	}
	path = g_strdup(gtk_entry_get_text(GTK_ENTRY(combo)));
	tfile = g_concat_dir_and_file(path, "gchiveXXXXXX");
	tf2 = mkstemp(tfile);
	if (	(chdir(path)<0)
		|| (!gnochive_can_create(tfile))
		|| (tf2 < 0)	)
		gnochive_error(errno, _("Could not extract %s !\n"), file_name);
	else {
		error = extract_to_path(file_name, path, files);
		if (error)
		{
			temp = g_strdup_printf(_("Extracted %s to %s !"), file_name, path);
			gnome_app_flash(GNOME_APP(gnochivemain->mainwin), temp);
			g_free(temp);
		}
		else {
			temp = g_strdup_printf(_("Could not extract %s !"),file_name);
			mbox = gnome_message_box_new(temp, GNOME_MESSAGE_BOX_ERROR, _("OK"), NULL);
			gnome_dialog_run_and_close(GNOME_DIALOG(mbox));
			g_free(temp);
		}
	}
	close(tf2);
	remove(tfile);
	//remove(tfile2);
	g_free(name);
	g_free(pwd);
	g_free(tfile);
	g_free(path);
	g_free(file_name);
	g_free(files);
}


void
on_button200_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	g_print("close");
}


void
on_checkbutton65_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
int togg = gtk_toggle_button_get_active(togglebutton) ? TRUE : FALSE;
if (togg != gnochivemain->gc_cfg->internal)
	gnome_property_box_changed((GnomePropertyBox *)gnochivemain->gc_cfg->widget);
gnochivemain->gc_cfg->internal = togg;
}


void
on_button168_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button170_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{

}

void
on_checkbutton102_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
gnochivemain->gc_cfg->overwrite = 1 - gnochivemain->gc_cfg->overwrite;
}


void
on_item4_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

void
on_checkbutton110_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	my_ad->volume = 1;
}


void
on_checkbutton109_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	GtkWidget *pass = lookup_widget(GTK_WIDGET(togglebutton), "entry58");
	gboolean state = 1 - (1-(int)gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(togglebutton)));
	my_ad->locked = state;
	gtk_widget_set_sensitive(GTK_WIDGET(pass), state);
}


void
on_radiobutton33_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	gnochivemain->gc_cfg->all = FALSE;
}


void
on_radiobutton34_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	gnochivemain->gc_cfg->all = TRUE;
}


void
on_vd_ok_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_destroy(GTK_WIDGET(user_data));
}


void
on_vd_cancel_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_destroy(GTK_WIDGET(user_data));
}

void
on_notebook7_switch_page               (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        gint             page_num,
                                        gpointer         user_data)
{
	GtkWidget *entryrpm = NULL, *entrycpio = NULL;
	GtkWidget *entryrpm2 = NULL, *entrycpio2 = NULL;
	GtkWidget *st1 = NULL, *st2 = NULL;
	GtkWidget *st3 = NULL, *st4 = NULL;
	GtkWidget *myprops = NULL;
	gchar *text1 = NULL, *text2 = NULL;
	
	if (page_num == 5)
	{
		myprops = gnochivemain->gc_cfg->widget;
		entryrpm = lookup_widget(GTK_WIDGET(myprops), "entry62");
		entrycpio = lookup_widget(GTK_WIDGET(myprops), "entry65");
		entryrpm2 = lookup_widget(GTK_WIDGET(myprops), "entry67");
		entrycpio2 = lookup_widget(GTK_WIDGET(myprops), "entry68");
		st1 = lookup_widget(GTK_WIDGET(myprops), "label286");
		st2 = lookup_widget(GTK_WIDGET(myprops), "label337");
		st3 = lookup_widget(GTK_WIDGET(myprops), "label332");
		st4 = lookup_widget(GTK_WIDGET(myprops), "label341");
		
		text1 = gtk_entry_get_text(GTK_ENTRY(entryrpm));
		text2 = gtk_entry_get_text(GTK_ENTRY(entrycpio));
		gtk_entry_set_text(GTK_ENTRY(entryrpm2), text1);
		gtk_entry_set_text(GTK_ENTRY(entrycpio2), text2);
		gtk_label_get(GTK_LABEL(st1), &text1);
		gtk_label_get(GTK_LABEL(st2), &text2);
		gtk_label_set_text(GTK_LABEL(st3), text1);
		gtk_label_set_text(GTK_LABEL(st4), text2);
	}
}

