/*  GUI frontend for common compresion programs
 *  Copyright 2000-2001  Lucian Langa
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _GNOCHIVE_H_
#define _GNOCHIVE_H_

#include <gnome.h>

#include "toolbar.h"
#include "misc.h"
#include "gc_setup.h"
#include "components.h"
#include "dnd.h"

typedef struct _gchivemain gchivemain;
struct _gchivemain
{
	GtkWidget 		*op_filesel;
	GtkWidget 		*sv_filesel;
	GtkWidget		*dirsel;
	GtkWidget		*dirparent;
	GtkWidget		*mainwin;
	GtkWidget		*mainbar;
	GtkWidget		*location_entry;
	GtkWidget		*vport;
	GtkWidget		*log_window;
	MainMenu		*menubar;
	GtkWidget		*mainmenu;
	GnomeApp		*app;
	gnochive_config *gc_cfg;
	gchar			*current_archive;
	GtkWidget		*noter;
	pager			*gc_pager;			//first page in the list
	pager			*active_page;
	qpack			*qdialog;			//quick menu used for packing files through contextual menus
	mydnd			*dnd;
};

void
on_new_file1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_clear1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_homepage_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_report_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_about2_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_button8_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_cancel_button1_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_text1_show                          (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_clist1_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_clist1_add                          (GtkContainer    *container,
                                        GtkWidget       *widget,
                                        gpointer         user_data);

void
on_clist1_show                         (GtkWidget       *widget,
                                        gpointer         user_data);


void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_close1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_clist1_select_all                   (GtkCList        *clist,
                                        gpointer         user_data);

void
on_clist1_unselect_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_button21_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button22_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_clist1_unselect_all                 (GtkCList        *clist,
                                        gpointer         user_data);

void
on_clist1_unselect_all                 (GtkCList        *clist,
                                        gpointer         user_data);

void
on_app1_set_focus                      (GtkWindow       *window,
                                        GtkWidget       *widget,
                                        gpointer         user_data);

void
on_button7_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
on_button7_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
on_app1_destroy                        (GtkObject       *object,
                                        gpointer         user_data);

void
on_app1_draw                           (GtkWidget       *widget,
                                        GdkRectangle    *area,
                                        gpointer         user_data);

void
on_app1_draw_default                   (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_app1_show                           (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_app1_show                           (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_app1_show                           (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_ok_button2_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_button24_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_select_all1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_ok_button2_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_button24_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_cancel_button2_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_cancel_button2_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_button7_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
on_button7_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
on_selected_file1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_test_archive1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_add_comment1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
int
cmpare(char *s1,char *s2);

void
on_ok_button3_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_cancel_button3_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_ok_button3_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_fileselection3_destroy              (GtkObject       *object,
                                        gpointer         user_data);

void
on_clist1_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_clist1_select_all                   (GtkCList        *clist,
                                        gpointer         user_data);

void
on_clist1_unselect_all                 (GtkCList        *clist,
                                        gpointer         user_data);

void
on_clist1_unselect_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_button21_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_optionmenu2_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_checkbutton14_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_combo_entry1_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_combo_entry1_activate               (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_optionmenu2_released                (GtkButton       *button,
                                        gpointer         user_data);

void
on_radiobutton1_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton2_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton3_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton1_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton2_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton3_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_combo_entry2_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_combo_entry3_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_entry5_changed                      (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_window2_destroy                     (GtkObject       *object,
                                        gpointer         user_data);

void
on_button37_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button38_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_app1_set_focus                      (GtkWindow       *window,
                                        GtkWidget       *widget,
                                        gpointer         user_data);

void
on_app1_show                           (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_clist1_select_all                   (GtkCList        *clist,
                                        gpointer         user_data);

void
on_clist1_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_clist1_unselect_all                 (GtkCList        *clist,
                                        gpointer         user_data);

void
on_clist1_unselect_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_combo_entry4_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_combo_entry4_activate               (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_entry6_activate                     (GtkEditable     *editable,
                                        gpointer         user_data);

gboolean
on_clist1_button_press_event           (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
on_clist1_button_press_event           (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

int
test_inserted(int list_size,gchar *myword);


void
on_combo_entry4_activate               (GtkEditable     *editable,
                                        gpointer         user_data);

gboolean
on_clist1_drag_drop                    (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        guint            time,
                                        gpointer         user_data);

void
on_clist1_drag_data_get                (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_clist1_drag_end                     (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gpointer         user_data);

gboolean
on_clist1_drag_motion                  (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        guint            time,
                                        gpointer         user_data);

void
on_eventbox1_drag_data_received        (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

gboolean
on_eventbox1_drag_drop                 (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        guint            time,
                                        gpointer         user_data);

void
on_clist1_drag_begin                   (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gpointer         user_data);

void
on_clist1_add                          (GtkContainer    *container,
                                        GtkWidget       *widget,
                                        gpointer         user_data);

void
on_clist1_drag_data_received           (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_clist1_drag_data_get                (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_clist1_drag_data_received           (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_clist1_drag_data_received           (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
create_right_menus			(void);

gboolean
on_eventbox1_button_press_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

void myfnc_sel				(void);
void myfnc_unsel			(void);

void
on_item2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

gboolean
on_eventbox1_motion_notify_event       (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data);

gboolean
on_eventbox1_enter_notify_event        (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data);

gboolean
on_clist1_enter_notify_event           (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data);

gboolean
on_eventbox2_button_press_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
on_eventbox2_motion_notify_event       (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data);

gboolean
on_eventbox2_enter_notify_event        (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data);

gboolean
on_eventbox1_button_press_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
on_eventbox1_motion_notify_event       (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data);

gboolean
on_eventbox1_enter_notify_event        (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data);

void
on_clist1_drag_begin                   (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gpointer         user_data);

void
on_clist1_start_selection              (GtkCList        *clist,
                                        gpointer         user_data);

gboolean
on_clist1_drag_motion                  (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        guint            time,
                                        gpointer         user_data);

void
on_clist1_row_move                     (GtkCList        *clist,
                                        gint             arg1,
                                        gint             arg2,
                                        gpointer         user_data);

void
on_combo_entry5_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_radiobutton10_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton1_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton2_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_combo_entry1_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_radiobutton1_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton2_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_combo_entry3_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_optionmenu1_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_optionmenu1_pressed                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_optionmenu1_released                (GtkButton       *button,
                                        gpointer         user_data);

void
on_optionmenu1_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_combo_entry6_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_combo_entry6_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_button45_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_window4_show                        (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_window4_show                        (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_checkbutton25_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_button20_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button19_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_checkbutton38_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton10_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton11_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton11_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton10_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_combo_entry6_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_button57_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_combo_entry6_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_button60_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button61_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button62_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_radiobutton16_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton17_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton18_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_button69_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button68_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button69_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button69_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_fixed31_show                        (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_button75_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button76_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button75_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button76_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button76_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button75_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button79_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button7_show                        (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_button7_show                        (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_button81_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_optionmenu1_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_optionmenu1_pressed                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_optionmenu1_released                (GtkButton       *button,
                                        gpointer         user_data);

void
on_combo_entry12_changed               (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_dialog1_show                        (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_button84_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_build_installer1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_close_this_window1_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_close_all_activate         (GtkMenuItem     *menuitem,
                               gpointer         user_data);

void
on_combo_entry4_drag_data_received     (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

gboolean
on_combo_entry14_key_press_event       (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

void
on_button90_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button90_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void normal_startup				(GtkWidget *mainwin);
void process_archive			(GtkWidget *mainwin,gchar *argarc[]);

void
on_checkbutton19_released              (GtkButton       *button,
                                        gpointer         user_data);

void
on_checkbutton20_toggled		(GtkToggleButton	*togglebutton,
					gpointer		user_data);
					

void
on_button23_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_log1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_estimate_repack1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_propertybox3_apply                  (GnomePropertyBox *gnomepropertybox,
                                        gint             arg1,
                                        gpointer         user_data);

void
on_propertybox3_help                   (GnomePropertyBox *gnomepropertybox,
                                        gint             arg1,
                                        gpointer         user_data);

void
on_propertybox3_show                   (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_propertybox3_show                   (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_checkbutton58_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_checkbutton58_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

gchar*
parse_direct				(gint j);

void
prepare_arc_menu			(void);

gboolean
on_combo_entry4_key_press_event        (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

gboolean
on_clist1_key_release_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

void
on_radiobutton26_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton18_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton26_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton27_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton27_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_entry44_changed                     (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_button107_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_button108_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_dialog13_show                       (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_button107_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_combo_entry17_changed               (GtkEditable     *editable,
                                        gpointer         user_data);

gboolean
open_archive				(gchar *archive);

void
update_main				(gchar *file_name,gboolean type);

gchar*
view_normal_file			(gchar *file_name);

void
on_checkbutton67_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

GtkWidget*
viewdialog				(void);

void
on_button76_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button110_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_button110_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_tree1_select_child                  (GtkTree         *tree,
                                        GtkWidget       *widget,
                                        gpointer         user_data);

void
on_tree1_selection_changed             (GtkTree         *tree,
                                        gpointer         user_data);

void
on_cclist_toggled                      (GtkToggleButton *togglebutton,
                                        gboolean         user_data);

void
on_path_clicked                        (GtkButton       *button,
                                        gint         user_data);


void
display_arc_status			(gchar *path,GtkEntry *entry,GtkLabel *label);

void
on_pentry_changed                      (GtkEditable     *editable,
                                        gpointer         user_data);


void
parse_pentry				(GtkFileSelection *win,
					gint	user_data);

void
on_checkbutton94_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_item2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_clist1_drag_begin                   (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gpointer         user_data);

void
on_clist1_drag_end                     (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gpointer         user_data);


gboolean
on_combo_entry18_key_press_event       (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

void
on_combo_entry18_activate              (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_targz1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_tarbz1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_tarz1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
dig_items				(GtkWidget *widget);

gchar*
extract_arch_name			(gchar *arch);

guint
pos_compare				(const gchar *s1,const gchar *s2);

gboolean
init_gnome_progress			(void);


void
on_compress_estimate_show              (GtkWidget       *widget,
                                        gpointer         user_data);

GtkWidget*
my_anim (gchar *widget_name, gchar *imgname, gchar *string2,
                gint size, gint freq);

void
refresh_dir			(gchar *dir);

void
gnochive_open_file_from_toolbar(void);

void on_gcopen_func(GtkButton *button, gpointer data);

void
on_appearance_changed               (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_radiobutton28_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton29_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton30_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

gint gtk_radio_button_get (GtkRadioButton *radio_button);
void gtk_radio_button_set (GtkRadioButton *radio_button, gint index);

gint
on_propertybox3_close                  (GnomeDialog     *gnomedialog,
                                        gpointer         user_data);

void gnochive_init	(GtkWidget *mainwin);

void
on_notebook_switch_page               (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        gint             page_num,
                                        gpointer         user_data);

void
on_button196_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_button197_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_button196_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_main_toolbar1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_extended_toolbar1_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_location_toolbar1_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_item8_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_un_select_all1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_copy2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_properties2_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
void
destroy_quick_dialog(void);

#endif

void
on_button201_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_button198_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_button200_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_checkbutton65_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_button168_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_button170_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_checkbutton102_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_item4_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_checkbutton110_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_checkbutton109_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton33_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton34_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_vd_ok_clicked                       (GtkButton       *button,
                                        gpointer         user_data);

void
on_vd_cancel_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

gboolean
gnochive_key_press_event           (GtkWidget       *widget,
									GdkEventKey  *event,
									gpointer         user_data);

gboolean
gnochive_key_release_event           (GtkWidget       *widget,
									  GdkEventKey  *event,
									  gpointer         user_data);

void gnochive_jump_to_page(gint page_num);

void
on_notebook7_switch_page               (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        gint             page_num,
                                        gpointer         user_data);
