/*  GUI frontend for common compresion programs
 *  Copyright 2000-2001  Langa Lucian
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <unistd.h>
#include <pwd.h>
#include <wait.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "interface.h"
#include "conf.h"
#include "gnochive.h"
#include "zip.h"
#include "gnochive.h"

#include "archs.h"
#include "lz.h"

#define TIMEOUT_GTK 5

extern gchivemain *gnochivemain;

extern GdkPixmap 	*dirpix,*docpix,*xpmpix,*makpix;
extern GdkPixmap	*rpmpix,*comppix,*dotpix,*lockpix;
extern GdkPixmap *hdrpix,*sympix,*rdpix,*rpm1pix;

extern GdkBitmap 	*dirmask,*docmask,*xpmmask,*makmask;
extern GdkBitmap	*rpmmask,*compmask,*dotmask,*lockmask;
extern GdkBitmap *hdrmask,*symmask,*rdmask,*rpm1mask;

extern gchar *arc_type;

extern GtkWidget *arcmenu1;

extern gchar *directory_read;
extern gchar *directory_up;

extern gfloat step;
extern float progr;
extern gchar *opd_archive_name;
extern int last_select_row;

static guint mytime(gpointer data);

/* lha handling functions
 *
 *	0 - no error, file opened
 *	1 - error not a rar archive
*/
int
lha_open(pager *page, gchar *file_name)
{
	gint status = 0;
	gchar *myfile = g_strdup(file_name);
	gint i, j, line, vline = 0, e=0, k;
	guint arcsize;
	guint time_id = 0;
	gchar *arcfile = NULL;
	FILE *tempfile;
	gchar xfr[0x100];
	gchar *clist_line[9] = {"","","","","","","","",""};
	gboolean error, is_dr = FALSE, dirprs = FALSE;
	gchar *dirs[512], *tdir = NULL, *rbase2;
	pid_t pid;
	gchar *temp_name = g_concat_dir_and_file(TMPDIR,"gchiveXXXXXX");
	int tf = mkstemp(temp_name);
	
	if (tf) {
	step = 0.01;
	progr = 0.1;
	
	time_id = gtk_timeout_add(TIMEOUT_GTK, (GtkFunction)mytime, NULL);
	gtk_clist_freeze(GTK_CLIST(page->clist));
	gtk_clist_clear(GTK_CLIST(page->clist));
	clist_line[1] = directory_read;
	gtk_clist_append(GTK_CLIST(page->clist), clist_line);
	clist_line[1] = directory_up;
	gtk_clist_append(GTK_CLIST(page->clist), clist_line);
	gtk_clist_set_pixmap(GTK_CLIST(page->clist), 1, 0, dotpix, dotmask);
	vline = line = 2;
	pid = gnochive_exec_arch("/tmp/zpvw", "zpvw",
			gnochivemain->gc_cfg->archs.lha_path,
			"l", myfile, temp_name, NULL);
	while (!waitpid(pid, &status, WNOHANG))
	{
		error = (WEXITSTATUS(status)<0);
		while (gtk_events_pending())
			gtk_main_iteration();
	}
	tempfile = fopen(temp_name,"r");
	fseek(tempfile, 0L, SEEK_END);
	arcsize = ftell(tempfile);
	arcfile = g_malloc0(arcsize);
	fseek(tempfile, 0L, SEEK_SET);
	fread(arcfile, 1, arcsize, tempfile);
	fclose(tempfile);
	i=0x87;
	while (arcfile[i]!=0x0A && (arcfile[i+1]!=0x2D && arcfile[i+2]!=0x2D))
	{
 	j=0;
 	while (arcfile[i]!=0x20) {
		xfr[j]=arcfile[i];
		i++;j++;
	}
	xfr[j]='\0';
	clist_line[6] = g_strdup(xfr);
 	 j=0;i++;
 	 //skip uid/gid
 	i+=11;
 	while (arcfile[i]==0x20) i++;
 	j=0;
	while (arcfile[i]!=0x20) {
		xfr[j] = arcfile[i];
		i++;j++;
	}
	xfr[j]='\0';
	clist_line[3] = g_strdup(xfr);
 	while (arcfile[i]==0x20) i++;
 	j=0;
 	while (arcfile[i]!=0x20) {
		xfr[j]=arcfile[i];
		i++;j++;
		if (arcfile[i]=='.') i+=2;
	}
	xfr[j]='\0';
	clist_line[8]=g_strdup(xfr);
 	while (arcfile[i]==0x20) i++;
 	j=0;
 	while (arcfile[i]!=0x20) {
		xfr[j]=arcfile[i];
		i++;j++;
	}
 	xfr[j]=' ';i++;j++;
 	if (arcfile[i]==' ') {
		xfr[j]='0';
		i++;j++;
	}
 	while (arcfile[i]!=0x20) {
		xfr[j]=arcfile[i];
		i++;j++;
	}
 	xfr[j]=' ';i++;j++;
 	if (arcfile[i]==' ') {
		xfr[j]=' ';
		i++;j++;
	}
 	while (arcfile[i]!=0x20) {
		xfr[j]=arcfile[i];
		i++;j++;
	}
	xfr[j]='\0';
	clist_line[5]=g_strdup(xfr);
 	while (arcfile[i]==0x20) i++;
 	j=0;
 	while (arcfile[i]!=0x0A) {
		xfr[j]=arcfile[i];
		i++;j++;
	}
	xfr[j]='\0';
	clist_line[1] = g_strdup(xfr);
	i++;
	is_dr = sort_dirs(clist_line[1]);
	tdir = extract_root_word(clist_line[1], 1);	
	if (e==0)
	{
		if (is_dr) 
		{
			dirs[e] = extract_root_word(clist_line[1], 1);
			e++;
			(gchar *)clist_line[1] = tdir;
			gtk_clist_append(GTK_CLIST(page->clist), clist_line);
			gtk_clist_set_pixmap(GTK_CLIST(page->clist),
				vline, 0, dirpix, dirmask);
			vline++;
			is_dr = FALSE;
		}
		else
		{
			if (!process_line(clist_line[1])) {
				gtk_clist_append(GTK_CLIST(page->clist), clist_line);
				gtk_clist_set_pixmap(GTK_CLIST(page->clist),
					vline, 0, docpix, docmask);
				vline++;
			}
			else
			{
				rbase2 = extract_root_word(clist_line[1], 1);
				dirprs = FALSE;
				for (k=0;k<e;k++)
				{
					if (!cmpare(dirs[k], rbase2))
						dirprs = TRUE;
				}
				g_free(rbase2);
				if (!dirprs)
				{
					dirs[e] = extract_root_word(clist_line[1], 1);
					e++;
					/* found a new dir and append it in the clist */
					(gchar *)clist_line[1] = extract_root_word(clist_line[1], 1);
					(gchar *)clist_line[3] = g_strdup("0");
					(gchar *)clist_line[6] = g_strdup("drwxrwxr-x");
					gtk_clist_append(GTK_CLIST(page->clist), clist_line);
					gtk_clist_set_pixmap(GTK_CLIST(page->clist),
						vline, 0, dirpix, dirmask);
					vline++;
				}
			}
		}
	}
	else {
	if (is_dr) 
	{
		is_dr = FALSE;
		dirprs = FALSE;
		for (k=0;k<e;k++)
		{
			if (!cmpare(dirs[k], tdir))
				dirprs = TRUE;
		}
		if (!dirprs)
		{
			dirs[e] = extract_root_word(clist_line[1], 1);
			e++;
			/* found a new dir and append it in the clist */
			(gchar *)clist_line[1] = tdir;
			gtk_clist_append(GTK_CLIST(page->clist), clist_line);
			gtk_clist_set_pixmap(GTK_CLIST(page->clist),
				vline, 0, dirpix, dirmask);
			vline++;
		}
	}
	else
	{
		if (!process_line(clist_line[1])) {
			gtk_clist_append(GTK_CLIST(page->clist), clist_line);
			gtk_clist_set_pixmap(GTK_CLIST(page->clist),
				vline, 0, docpix, docmask);
			vline++;
		}
		else
		{
			dirprs = FALSE;
			for (k=0;k<e;k++)
			{
				if (!cmpare(dirs[k], tdir))
					dirprs = TRUE;
			}
			if (!dirprs)
			{
				dirs[e] = extract_root_word(clist_line[1], 1);
				e++;
				/* found a new dir and append it in the clist */
				(gchar *)clist_line[1] = tdir;
				(gchar *)clist_line[3] = g_strdup("0");
				(gchar *)clist_line[6] = g_strdup("drwxrwxr-x");
				gtk_clist_append(GTK_CLIST(page->clist), clist_line);
				gtk_clist_set_pixmap(GTK_CLIST(page->clist),
					vline, 0, dirpix, dirmask);
				vline++;
			}
		}
	}
	}
	j=0;
	g_free(clist_line[3]);g_free(clist_line[6]);
	g_free(clist_line[8]);g_free(clist_line[5]);
}
page->current_lines = vline;
page->selected_rows = g_malloc0(page->current_lines);
status = 1;
}
gtk_clist_thaw(GTK_CLIST(page->clist));
gtk_timeout_remove(time_id);
gnome_appbar_set_progress(GNOME_APPBAR(gnochivemain->mainbar),1);
page->ad->data = arcfile;
page->ad->root = g_strdup("\0");
page->ad->depth = 1;
page->opd_archive = TRUE;
close(tf);
remove(temp_name);
g_free(temp_name);
g_free(myfile);
status = 1;
return status;
}

void
lha_cd		(GtkWidget *clst, gchar *child)
{
	int vline = 0;
	int line = 0;
	gint i = 0,j = 0, e = 0, k;
	gchar *tword = NULL;
	gchar *temp = NULL;
	gchar *arcfile = NULL;
	gchar xfr[100];
	gint row, arcsize;
	gchar *clist_line[9] = {"", "", "", "", "", "", "", "", ""};
	gchar *dirs[512], *tdir = NULL;
	gboolean is_dr = FALSE, dirprs = FALSE;
	line = vline = 2;
	
	while (gtk_events_pending())
		gtk_main_iteration();
	
	gtk_clist_freeze(GTK_CLIST(clst));
	gtk_clist_clear(GTK_CLIST(gnochivemain->active_page->clist));
	g_free(gnochivemain->active_page->selected_rows);
	
	gtk_clist_set_auto_sort(GTK_CLIST(clst),1);
	gtk_clist_set_sort_column(GTK_CLIST(clst),2);
	gtk_clist_set_sort_type(GTK_CLIST(clst),GTK_SORT_DESCENDING);
	gtk_clist_sort(GTK_CLIST(clst));
	
	arcfile = gnochivemain->active_page->ad->data;
	arcsize = strlen(arcfile);
	i=0x87;
	while (arcfile[i]!=0x0A && (arcfile[i+1]!=0x2D && arcfile[i+2]!=0x2D))
	{
 	j=0;
 	while (arcfile[i]!=0x20) {
		xfr[j]=arcfile[i];
		i++;j++;
	}
	xfr[j]='\0';
	clist_line[6] = g_strdup(xfr);
 	 j=0;i++;
 	 //skip uid/gid
 	i+=11;
 	while (arcfile[i]==0x20) i++;
 	j=0;
	while (arcfile[i]!=0x20) {
		xfr[j] = arcfile[i];
		i++;j++;
	}
	xfr[j]='\0';
	clist_line[3] = g_strdup(xfr);
 	while (arcfile[i]==0x20) i++;
 	j=0;
 	while (arcfile[i]!=0x20) {
		xfr[j]=arcfile[i];
		i++;j++;
		if (arcfile[i]=='.') i+=2;
	}
	xfr[j]='\0';
	clist_line[8]=g_strdup(xfr);
 	while (arcfile[i]==0x20) i++;
 	j=0;
 	while (arcfile[i]!=0x20) {
		xfr[j]=arcfile[i];
		i++;j++;
	}
 	xfr[j]=' ';i++;j++;
 	if (arcfile[i]==' ') {
		xfr[j]='0';
		i++;j++;
	}
 	while (arcfile[i]!=0x20) {
		xfr[j]=arcfile[i];
		i++;j++;
	}
 	xfr[j]=' ';i++;j++;
 	if (arcfile[i]==' ') {
		xfr[j]=' ';
		i++;j++;
	}
 	while (arcfile[i]!=0x20) {
		xfr[j]=arcfile[i];
		i++;j++;
	}
	xfr[j]='\0';
	clist_line[5]=g_strdup(xfr);
 	while (arcfile[i]==0x20) i++;
 	j=0;
 	while (arcfile[i]!=0x0A) {
		xfr[j]=arcfile[i];
		i++;j++;
	}
	xfr[j]='\0';
	clist_line[1] = g_strdup(xfr);
	i++;
	if (cmpare(xfr, child) == 0)
	{
		is_dr = sort_dirs(xfr);
		if (e==0 && strcmp(xfr, child) != 0)
		{
			if (is_dr) 
			{
				dirs[e] = extract_root_word(xfr,
					gnochivemain->active_page->ad->depth);
				e++;
				clist_line[1] = trim_root_word(child, xfr);
				clist_line[2] = "dir";
				row = gtk_clist_insert(GTK_CLIST(clst), 0, clist_line);
				gtk_clist_set_pixmap(GTK_CLIST(clst), row, 0, dirpix, dirmask);
				g_free(clist_line[1]);
				vline++;
				is_dr = FALSE;
			}
			else
			{
				gchar *rbase2 = trim_root_word(child, xfr);
				if (!process_line(rbase2)) {
					clist_line[1] = trim_root_word(child, xfr);
					clist_line[2] = " ";
					row = gtk_clist_insert(GTK_CLIST(clst), 0, clist_line);
					gtk_clist_set_pixmap(GTK_CLIST(clst),
						row, 0, docpix,docmask);
					g_free(clist_line[1]);
					vline++;
				}
				else
				{
					gchar *rbase3 = extract_root_word(xfr, gnochivemain->active_page->ad->depth);
					dirprs = FALSE;
					for (k=0;k<e;k++)
					{
						if (!cmpare(rbase3, dirs[k]))
							dirprs = TRUE;
					}
					if (!dirprs)
					{
						dirs[e] = extract_root_word(xfr, gnochivemain->active_page->ad->depth);
						e++;
						/* found a new dir and append it in the clist */
						(gchar *)clist_line[1] = trim_root_word(child, rbase3);
						(gchar *)clist_line[3] = g_strdup("0");
						(gchar *)clist_line[6] = g_strdup("drwxrwxr-x");
						row = gtk_clist_insert(GTK_CLIST(clst), 0, clist_line);
						gtk_clist_set_pixmap(GTK_CLIST(clst), row, 0, dirpix, dirmask);
						g_free(clist_line[1]);
						vline++;
					}
					g_free(rbase3);
				}
				g_free(rbase2);
			}
		}
		else if (e>0  && strcmp(xfr, child) != 0)
		{
			if (is_dr && strcmp(xfr, child) != 0)
			{
				tdir = extract_root_word(xfr,
					gnochivemain->active_page->ad->depth);
				is_dr = FALSE;
				dirprs = FALSE;
				for (k=0;k<e;k++)
				{
					if (!cmpare(tdir, dirs[k]))
						dirprs = TRUE;
				}
				if (!dirprs)
				{
					dirs[e] = extract_root_word(xfr,
						gnochivemain->active_page->ad->depth);
					e++;
					/* found a new dir and append it in the clist */
					(gchar *)clist_line[1] = trim_root_word(child, tdir);
					row = gtk_clist_insert(GTK_CLIST(clst), 0, clist_line);
					gtk_clist_set_pixmap(GTK_CLIST(clst), row, 0, dirpix, dirmask);
					g_free(clist_line[1]);
					vline++;
				}
				g_free(tdir);
			}
			else
			{
				gchar *rbase2 = trim_root_word(child, xfr);
				if (!process_line(rbase2)) {
					clist_line[1] = trim_root_word(child, xfr);
					clist_line[2] = " ";
					row = gtk_clist_insert(GTK_CLIST(clst), 0, clist_line);
					gtk_clist_set_pixmap(GTK_CLIST(clst),
						row, 0, docpix,docmask);
					g_free(clist_line[1]);
					vline++;
				}
				else
				{
					tdir = extract_root_word(xfr,
						gnochivemain->active_page->ad->depth);
					dirprs = FALSE;
					for (k=0;k<e;k++)
					{
						if (!cmpare(dirs[k], tdir))
							dirprs = TRUE;
					}
					if (!dirprs)
					{
						dirs[e] = extract_root_word(xfr,
							gnochivemain->active_page->ad->depth);
						e++;
						/* found a new dir and append it in the clist */
						(gchar *)clist_line[1] = trim_root_word(child, tdir);
						(gchar *)clist_line[3] = g_strdup("0");
						(gchar *)clist_line[6] = g_strdup("drwxrwxr-x");
						row = gtk_clist_insert(GTK_CLIST(clst), 0, clist_line);
						gtk_clist_set_pixmap(GTK_CLIST(clst), row, 0, dirpix, dirmask);
						g_free(clist_line[1]);
						vline++;
					}
					g_free(tdir);
				}
				g_free(rbase2);
			}
		}
	}
	//g_free(clist_line[6]);g_free(clist_line[3]);
	//g_free(clist_line[5]);g_free(clist_line[8]);
	}
	for (i=0;i<=9;i++)
		clist_line[i] = "\0";
	gtk_clist_set_auto_sort(GTK_CLIST(clst), 0);	
	clist_line[1] = g_strdup(directory_up);
	gtk_clist_prepend(GTK_CLIST(clst), clist_line);
	gtk_clist_set_pixmap(GTK_CLIST(clst), 0, 0, dotpix, dotmask);
	g_free(clist_line[1]);
	clist_line[1] = g_strdup(directory_read);
	gtk_clist_prepend(GTK_CLIST(clst), clist_line);
	g_free(clist_line[1]);
	gnochivemain->active_page->current_lines = vline;
	gnochivemain->active_page->selected_rows = 
						g_malloc0(gnochivemain->active_page->current_lines);
	temp = g_strdup(child);
	if (temp[0] == '/')
	{
		g_free(gnochivemain->active_page->ad->root);
		gtk_entry_set_text(GTK_ENTRY(arcmenu1), "\0");
		gnochivemain->active_page->ad->root = g_strdup("\0");
	}
	else
	{
		g_free(gnochivemain->active_page->ad->root);
		gtk_entry_set_text(GTK_ENTRY(arcmenu1), temp);
		gnochivemain->active_page->ad->root = g_strdup(child);
	}
	g_free(temp);
	gtk_clist_thaw(GTK_CLIST(clst));
	g_free(tword);
}

void
lhapack(void)
{
	GtkWidget *dialog;
	
	//strcpy(q_ext,".lha");
	/* FIXME strcpy(comp_command,"-9");*/
	(gchar *)arc_type="lha";
	dialog=create_quick_pack();
	gtk_widget_show(dialog);
}

/* Tests if given files it really an LZ/LZH
 * 0 - unknown file
 * 1 - lz method 0
 * 2 - lz method 1
 * 3 - lz method 2
 * 4 - lz method 3
 * 5 - lz method 4
 * 6 - lz method 5
 * 7 - lz method 6
 * 8 - larc
 * 9 - larc 5
 *10 - larc 4
 *11 - lzhdir
 */
 
gint
detect_lha		(gchar *file)
{
int status=0;
FILE *tmp;
gchar buff[0x10];
tmp=fopen(file,"r");
fread(buff,10,1,tmp);
fclose(tmp);
if (cmpare(buff,LZHUFF0)==0) return 1;
if (cmpare(buff,LZHUFF1)==0) return 2;
if (cmpare(buff,LZHUFF2)==0) return 3;
if (cmpare(buff,LZHUFF3)==0) return 4;
if (cmpare(buff,LZHUFF4)==0) return 5;
if (cmpare(buff,LZHUFF5)==0) return 6;
if (cmpare(buff,LZHUFF6)==0) return 7;
if (cmpare(buff,LARC)==0) return 8;
if (cmpare(buff,LARC5)==0) return 9;
if (cmpare(buff,LARC4)==0) return 10;
if (cmpare(buff,LZHDIR)==0) return 11;
return status;
}


static 
guint mytime(gpointer data)
{
	GDK_THREADS_ENTER();
	progr=progr+step;
	if (progr<=1)
		gnome_appbar_set_progress(GNOME_APPBAR(gnochivemain->mainbar),progr);
	else gnome_appbar_set_progress(GNOME_APPBAR(gnochivemain->mainbar),1);
	GDK_THREADS_LEAVE();
	return TRUE;
}
